/*
 * FASt Term Recognizer
 *
 *  FASTR/al-ext.h
 *  Version 2.04/04-02-01
 *
 *  Copyright (C) 2004  Christian Jacquemin, LIMSI-CNRS
 *
 *  This file contains constants and data structures
 */

/*****************************************************************************
                        variables internes
*****************************************************************************/

/* On appelle absolu un indice ou pointeur dans le fichier complet des
elements de ce type, on appelle relatif un indice ou pointeur vers un
buffer des elements de ce type present en memoire a cet instant.  */

/*****************************************************************************
                        constantes et macros
                        + variables internes
*****************************************************************************/
/* #define MACNONGRAPH */
/* #define MAC */
/* #define GENERATION */
/* #define RATTACHEMENT */
#define SUN
/* #define PC */
#define WARNINGS
/* #define BELLLABS */
#define _TailleMot  4L

/***************** PC ********************/
#ifdef PCold
#include <alloc.h>
#include <conio.h>
#include <dos.h>
#include <errno.h>
#include <fcntl.h>
#include <io.h>
#include <math.h>
#include <process.h>
#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#endif
/********************************************/

/***************** MAC ********************/
#ifdef MAC
#include <console.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <unix.h>
#include <math.h>
#endif

/***************** SUN ********************/
#ifdef SUN
#include <stdio.h>
#include <errno.h>
#include <ctype.h>
#include <math.h>
/* #include <curses.h>
#include <console.h>
#include <unix.h> */

#include <string.h>
#include <stdlib.h>
#include <time.h>
#endif

/***************** MAC NON GRAPHIQUE ********************/
#ifdef MACNONGRAPH

#define _MachineGraphique _False

#define _Cs()                               { if( !TraitementBatch ) printf("\f"); }
#define _LaDate(_ch)  \
     {\
          unsigned long _t = time(NULL);\
          strcpy(_ch,ctime(&_t));\
     }
#define _ChaineRsrc(_x,_y,_z)
#define _NouveauDialogueInfo(_x,_y)
#define _ClickDansAnnulerInfo() _False
#define _FinDialogueInfo()
#define  _FinLigne 1
#define _IniEcran() { printf(" " ); csetmode(C_CBREAK,stdin); \
                                    csetmode(C_CBREAK,stdout); \
                                    console_options.pause_atexit = 0; }
#define _EnTete(_x)
#define _ChargeFichierDicoSelectionne()
#define _BoucleAttenteEvenement()

#define _Alloc(_x)  malloc((unsigned long)_x)
#define _Free(_x)   free((void *)_x)
#define _Echo(_c)  printf("%c",_c)
#define _FopenAT    "a"
#define _FopenRB    "rb"
#define _FopenWB    "wb"
#define _FopenRT    "r"
#define _FopenWT    "w"
#define _FopenRPB   "r+b"
#define _FopenWPB   "w+b"
#define _FopenRPT   "r+"
#define _FopenWPT   "w+"
#endif

/***************** MAC GRAPHIQUE ********************/
#ifdef MACGRAPH

#define _MachineGraphique _True
#include "al-graph.h"

void Gprintf( char *p_chaine );

#define printf(c)                            Gprintf(c)
#define _Cs()                                EffaceFenetreTexte()
#define _LaDate(_ch)  \
     {\
          unsigned long _t = time(NULL);\
          strcpy(_ch,ctime(&_t));\
     }
#define _ChaineRsrc(_x,_y,_z)                ChaineRsrc(_x,_y,_z)
#define _NouveauDialogueInfo(_x,_y)          NouveauDialogueInfo(_x,_y)
#define _ClickDansAnnulerInfo()              ClickDansAnnulerInfo()
#define _FinDialogueInfo()                   FinDialogueInfo()
#define  _FinLigne 1
#define _IniEcran()      InitGraphisme()

#define _EnTete(_x)  EnTete(_x)
#define _ChargeFichierDicoSelectionne()  ChargeFichierDicoSelectionne()
#define _BoucleAttenteEvenement()   BoucleAttenteEvenement()

#define _Alloc(_x)  malloc((unsigned long)_x)
#define _Free(_x)   free((void *)_x)
#define _Echo(_c)  printf("%c",_c)
#define _FopenAT    "a"
#define _FopenRB    "rb"
#define _FopenWB    "wb"
#define _FopenRT    "r"
#define _FopenWT    "w"
#define _FopenRPB   "r+b"
#define _FopenWPB   "w+b"
#define _FopenRPT   "r+"
#define _FopenWPT   "w+"
#endif

/***************** DEC ********************/
/* version X pour VAX obsolete */
/* #ifdef DEC
#include <curses.h>
#include <decw$include/X.h>
#include <decw$include/Xos.h>
#include <decw$include/Xlib.h>
#include <decw$include/Xutil.h>
#include <decw$include/cursorfont.h>

#define _MachineGraphique  (DisplayCourant && ModeInteractif)
#define _IniEcran()\
    initscr();\
    DisplayCourant = XOpenDisplay(0);\
    if(DisplayCourant)\
    {\
        EcranCourant = XDefaultScreenOfDisplay(DisplayCourant);\
        XSynchronize(DisplayCourant,1);\
    }
#endif
*/

/***************** SUN ********************/
#ifdef SUN

#define Debugger();
#define fgetpos(_f,_p) *(_p) = ftell(_f);

#define _MachineGraphique  _False
/* (DisplayCourant && ModeInteractif) */

#define float double

#define _Cs()  \
    {\
       if( !TraitementBatch ) { printf("%c[2J",27);printf("\f"); }\
    }
#define _LaDate(_ch)  \
     {\
          time_t _t = time(NULL);\
          strcpy(_ch,(char *)ctime(&_t));\
     }
#define _ChaineRsrc(_x,_y,_z)
#define _NouveauDialogueInfo(_x,_y)
#define _ClickDansAnnulerInfo() _False
#define _FinDialogueInfo()

#ifdef PC
#define  _FinLigne 1
#else
#define  _FinLigne 1
#endif
#define _IniEcran()

#define _EnTete(_x)
#define _ChargeFichierDicoSelectionne()
#define _BoucleAttenteEvenement()

#define _Alloc(_x) (char *)malloc((unsigned long)(_x))
#define _Free(_x) free((void *)_x)
#define _Echo(_c)  printf("%c",_c)
#define _FopenRB    "rb"
#define _FopenWB    "wb"
#define _FopenRPB   "r+b"
#define _FopenWPB   "w+b"

#ifdef PCold
#define _FopenRT    "rb"
#define _FopenWT    "wb"
#define _FopenRPT   "r+b"
#define _FopenWPT   "w+b"
#else
#define _FopenRT    "rb"
#define _FopenWT    "wb"
#define _FopenRPT   "r+b"
#define _FopenWPT   "w+b"
#endif
#ifndef RAND_MAX
#define RAND_MAX 65536.0

#endif

#endif

/*************************************************************************
                       CONSTANTES DE CARACTERES SPECIAUX
*************************************************************************/

/***************** MAC ********************/
#ifdef MAC
#define _MinAlphaAcc -121
#define _MaxAlphaAcc -97
#endif

/***************** PC ********************/
/***************** SUN ********************/
#ifdef SUN
#ifdef PC
#define _MinAlphaAcc -127
#define _MaxAlphaAcc -105
#else
#define _MinAlphaAcc (char)-96
#define _MaxAlphaAcc (char)-1
#endif
#endif



/*************************************************************************
                           CONSTANTES
*************************************************************************/
#ifndef NULL
#define    NULL                     0L
#endif
#define    _Nil                     -1L

/* booleens  ou constantes predefines poour des appels de parametre     */
#define    _False                   0
#define    _True                    1

#define    _Alphabetique            0
#define    _Numerique               1

#define    _Lire                    0
#define    _Ecrire                  1

#define    _Regles                  0
#define    _Lemmes                  1
#define    _Liens                   2

#define    _Ecran                   0
#define    _Log                     1
#define    _Sortie                  2
#define    _SortieWithoutLF         3

#define    _Indexation              0
#define    _Analyse                 1
#define    _IndexationVariations    2
#define    _Variations              3
#define    _Etiquetage              4
#define    _EtiquetageFin           5
#define    _Collocations            6

#define    _Morphologie             0
#define    _Reconnaissance          1

/* format d'entree/sortie en analyse                                    */
#define    _Txt                     0
#define    _SortieInist             1
#define    _TxtNumerote             2
#define    _TxtTagge                3
#define    _TxtTaggePartiellement   4
#define    _SortieInistNum          5
#define    _SortieLexter            6
#define    _SortieInistSGML         7
#define    _SortieInistSGMLWithSem  8
#define    _SortieAmaryllis         9
#define    _SortieInistAvecLemmes   10
#define    _TxtFenTaggePartielt     11
#define    _SortieQA                12

/* format d'entree/sortie en analyse                                    */
#define    _JamaisMorphoDer         0
#define    _ToujoursMorphoDer       1
#define    _MorphoDerSiInconnu      2

/* trace de sortie en fin d'analyse                                     */
#define    _SortieSystematique      1
#define    _SortieSiIndex           2
#define    _SortieApresChaqueIndex  3

/* mode de traitement de la semantique : classses ou liens              */
#define    _SemantiqueDeClasses     1
#define    _SemantiqueDeLiens       2

/* mode de parcours d'un fichier de lemme (expansion ou taille fixe)    */
#define    _SansChangementDeTaille             1
#define    _AvecChangementDeTailleEtRecopie    2

/* mode de travail sur un lien morphologique                            */
#define    _RechercheLemmes         1
#define    _ChangeLemmes            2

/* constantes de retour en parcours d'arbre                             */
#define    _ArretParcoursFils       2

/* extrema alphabetiques des racines des U.L.R.                         */
#define    _RefNum                  9L
#define    _DebutRefPonctuation     900L
#define    _FinRefPonctuation       999L
#define    _PremRefLemme            1000L

/**     CONSTANTES POUR L'EFFACEMENT DES REGLES                         **/
#define    _BasPile                 _TailleMot

/**     CARACTERISTIQUES DES REGLES                                     **/
#define    _RacineAnnexeMax         -20
#define    _RacineAnnexe1           -2
#define    _RegleNonLiee            -10000
#define    _RefConjonctionNeg       -10001

/**     CARACTERISTIQUES DES FLEXIONS                                   **/
#define    _NbMaxSuffixages         100
#define    _TailSuffixage           10
#define    _TailListeSuffixes       400
#define    _NbMaxNoeudsSuffixe      300


/**     CARACTERISTIQUES DU DICO RESIDENT DES MOTS COURTS OU USUELS     **/
#define    _TailDucs                200
#define    _TailDucTerme            300

/**     TAILLES DE CHAINES                                              **/
#define    _MaxLetLong              10  /* taille max de la chaine d'un entier long */
#define    _MaxLetIdent             31
#define    _MaxLetMot               128 /* mot flechi du texte */
#define    _NbMaxLetNomFic          128
#define    _NbMaxLetBArb            6   /* nb car pour selectionner 1 porte*/
#define    _NbMaxLetChOut           1024

/**     CONSTANTES UTILSE EN GENERATION                                 **/
#define    _NbMaxRacinesAnnexes     4
#define    _MaxLetDicoEnum          5
#define    _DerCatLex               32
#define    _NbMaxMotsUneRegle       32
#define    _NbMaxConstMetaRegle     6       /* nb maximal de constituants en partie dte de MR */
#define    _FlexLexVide             -1L
#define    _NbMaxMotsClasses        50000L
#define    _NbCarOcc                300      /* nb caracteres d'une occurence de terme */
#define    _NbCarChaine             120      /* taille indic. d'1 ch de trm */

/**     CONSTANTES UTILSEES EN OPTIMISATION DE LA LEXICALISATION        **/
#define    _NbMaxLem                10000
#define    _NbMaxCandidats          3000
/* longueur maximale d'un regle compose et nombre maximal de repetition d'une
lemme dans un meme regle                                                  */
#define     _LongueurMax            127
#define     _NbMaxRepetition        127

/**     CONSTANTES UTILSEES EN MORPHOLOGIE                               **/
#define     _NbLetSuffMorpho        15
#define     _NbMaxMotsMorpho        4
#define     _TailChPaireTrmVarMorpho 256

/**     CONSTANTES UTILSEES EN SEMANTIQUE                                **/
#define     _NbMaxTypesLiensSem     15
#define     _NbMaxLiensSem          500

/**     TAILLES DE TABLEAUX                                              **/
#define    _NbMaxHomographe         30     /* nombre maximal d'homographes*/

#define    _NbMaxTableau            30     /* nb max de tblx de metaregles*/

#define    _MaxCarSpeciaux          32     /* nombre max de car speciaux  */

#define    _MaxMajorCategories      10     /* max # cat of non empty words  */
#define    _MaxBoucEnCours          100

/**             CONSTANTES D'AFFICHAGE D'ECRAN                           **/
#define    _NbLigneEcran            24
#define    _NbLColEcran             79


/**                     REFERENCE ABSOLUE  DES FICHIERS                  **/
/* longueur reservee au debut pour le compteur des ref absolues des Lemmes*/
#define    _TailleAmorce            sizeof(long)
/* longueur de la separation entre 2 blocs de lemme .                     */
#define    _TailleSeparation        3 * _TailleMot

/*****************************************************************************
                        MACROS
*****************************************************************************/
/* determine si un caractere est une ponctuation                        */
#define _Return(c) (c == '\n' || c == 13)
#define _EnterNum  3
#define _CarBlanc(c) (c == ' ' || _Return(c) || c == '\t')

/* determine si un caractere est alphabetique                           */
#define _Alpha(c) ((c >= 'a' && c <= 'z') \
                     || (c >= 'A' && c <= 'Z') \
                     || (c >= _MinAlphaAcc && c <= _MaxAlphaAcc))

/* determine si un caractere est numerique                              */
#define _Num(c) (c >= '0' && c <= '9')

/* determine si un caractere est alphanumerique                         */
#define _Alphanum(c) (_Alpha(c) || _Num(c))

/* minimum et maximum de 2 entiers                                      */
#define _Max(b,c) ((b)>(c)? (b):(c))
#define _Min(b,c) ((b)<(c)? (b):(c))

/* passage d'une majuscule a une minuscule                              */
#define _ToLower(c) ((c >='A' && c<='Z')? (c - 'A' + 'a'):c)
#define _ToUpper(c) ((c >='a' && c<='z')? (c - 'a' + 'A'):c)
#define _IsUpper(c) (c >='A' && c<='Z')
#define _IsLower(c) (c >='a' && c<='z')

/* lecture d'un caractere dans le fichier texte bufferise par BuffTexte,
   et qui est en cours de traitement lexical dans cette session         */
#define _LireC(ptF) ((IndCar<IndCarM)? BuffTexte[IndCar++]:LireBuffTexte(ptF))

/* recherche de l'indice relatif a partir de l'indice absolu du lemme ou
   de la chaine ou des pointeurs */
#define _IRelLemme(i) ( ((i)>=IndBuffLemmeMin && (i)<IndBuffLemmeMax)? \
                      ((long)(i-IndBuffLemmeMin)) : IndRelBDic(i,_Lemmes) )
#define _IRelRegle(i) ( ((i)>=IndBuffRegleMin && (i)<IndBuffRegleMax)? \
                      ((long)(i-IndBuffRegleMin)) : IndRelBDic(i,_Regles) )
#define _IRelLien(i) ( ((i)>=IndBuffLienMin && (i)<IndBuffLienMax)? \
                      ((long)(i-IndBuffLienMin)) : IndRelBDic(i,_Liens) )

/*****************************************************************************
                        TYPES ENUMERES
*****************************************************************************/
/*reponses a reponse binaire                                            */
typedef enum 
{
    _Oui    = 1,
    _Non,    
    _Annuler }    TypeItem;

typedef enum
{
    _TypeTermeVide = -1,

    _Concatenation = 1,
    _Liste,

    _RegleNormale, /* 3 */
    _RegleMeta,
    _RegleElision,

    _Feuille,          /* type de terme temporaire en compilation */
    _UniteLexicale,    /* avant departage suite a lecture dag     */
    _Regle,            /* 8 */

    _MotFlechi,
    _MotDerive,
    _MotRacine,
    _MotSemantLie,    /* 12 */
    _MotSemantLieRec, /* 13 */
    
    _MotSyntagme,
    
    _DerTypeTerme
}   TypeTermeRegle;

typedef enum
{
    _TypeDicoVide = -1,

    _Trait = 1,
    _CatLex,

    _DerTypeDico
}    TypeDico;

typedef enum
{
    _TypeAtomeVide = -1,

    _ConjonctionNeg = 1,
    _DisjonctionPos,

    _DerTypeAtome
}    TypeAtome;

typedef enum
{
    _TypeDagVide = -1,

    _AtomeEntier = 1,
    _AtomeChaine,
    _AtomeRef,
    _AtomeListe,
    _AtomeER,
    _Arc,
    _Oper,

    _DerTypeDag
}    TypeDag;

typedef enum
{
    _TabRegles = 0,
    _TabReglesMeta,
    _TabLemmes,
    _TabRefPhrase,
    _TabTermes,
    _TabDag,
    _TabMots,

    _DerTypeElemAllouable
}    TypeElemAllouable;    

typedef enum
{
    _PreOrdre,
    _InOrdre,
    _PostOrdre
}   OrdresDeParcours;

typedef enum
{
    _Moins = 1,
    _PlusOuMoins,
    _Plus
}    ValeurAcceptabilite;

typedef enum
{
    _ArcOrdinaire = -1,
    _ArcDebComptage = 1,
    _ArcFinComptage,
    _ArcSuiteComptage
}    TypeArcER;

/*****************************************************************************
                        CHAINES DE CARACTERES
*****************************************************************************/
/* un mot : une chaine maximale de lemme, dag, etc.     */
typedef char       ChIdent[ _MaxLetIdent + 1 ];
/* un mot : une chaine maximale d'une unite lexicale flechie du lexique     */
typedef char       ChMot[ _MaxLetMot + 1 ];

#ifdef PCold
typedef struct PorteNormale  huge             *TabPorteNormale;
typedef struct PorteSuperieure  huge          *TabPorteSuperieure;
typedef char huge                             *TabChar;
typedef int huge                              *TabInt;
typedef long huge                             *TabLong;
typedef struct DagMem huge                    *TabDagMem;
typedef struct RefPhraseMem huge              *TabRefPhraseMem;
typedef struct ValAtomeMem huge               *TabValAtomeMem;
typedef struct LemmeMem huge                  *TabLemmeMem;
typedef struct TermeMem huge                  *TabTermeMem;
typedef struct RegleMemMeta huge              *TabRegleMemMeta;
typedef struct RegleMem huge                  *TabRegleMem;
typedef struct MotMem huge                    *TabMotMem;
typedef struct NoeudSauve huge                *TabNoeudSauve;
typedef struct BlocInitial huge               *TabBlocInitial;
typedef struct CaractRemontees huge           *TabCaractRemontees;
typedef struct CorrIdent_PosFic huge          *TabCorrIdent_PosFic;
typedef struct DicoTraitsCatLex huge          *TabDicoTraitsCatLex;
typedef struct UnLienIdentTerme huge          *TabLiensIdentTerme;
typedef struct LienMemFic huge                *TabLienMemFic;
typedef struct LienMemVar huge                *TabLienMemVar;
typedef struct LemmesMots huge                *TabLemmesMots;
typedef struct CaracBouc huge                 *TabCaracBouc;
typedef struct ChaineTerme huge               *TabChaineTermes;
typedef struct TermedeLien huge               *TabTermedeLien;
typedef struct SequenceDeLiens huge           *TabSequenceDeLiens;
typedef struct Lien huge                      *TabLien;
#else 
typedef struct PorteNormale                   *TabPorteNormale;
typedef struct PorteSuperieure                *TabPorteSuperieure;
typedef char                                  *TabChar;
typedef int                                   *TabInt;
typedef long                                  *TabLong;
typedef struct DagMem                         *TabDagMem;
typedef struct RefPhraseMem                   *TabRefPhraseMem;
typedef struct ValAtomeMem                    *TabValAtomeMem;
typedef struct RegleMem                       *TabRegleMem;
typedef struct LemmeMem                       *TabLemmeMem;
typedef struct TermeMem                       *TabTermeMem;
typedef struct RegleMemMeta                   *TabRegleMemMeta;
typedef struct MotMem                         *TabMotMem;
typedef struct NoeudSauve                     *TabNoeudSauve;
typedef struct BlocInitial                    *TabBlocInitial;
typedef struct CaractRemontees                *TabCaractRemontees;
typedef struct CorrIdent_PosFic               *TabCorrIdent_PosFic;
typedef struct DicoTraitsCatLex               *TabDicoTraitsCatLex;
typedef struct UnLienIdentTerme               *TabLiensIdentTerme;
typedef struct LienMemFic                     *TabLienMemFic;
typedef struct LienMemVar                     *TabLienMemVar;
typedef struct LemmesMots                     *TabLemmesMots;
typedef struct CaracBouc                      *TabCaracBouc;
typedef struct ChaineTerme                    *TabChaineTermes;
typedef struct TermedeLien                    *TabTermedeLien;
typedef struct SequenceDeLiens                *TabSequenceDeLiens;
typedef struct Lien                           *TabLien;
#endif

/*************************************************************************
                            LES DICTIONNAIRES
*************************************************************************/
/* donnee de base des dictionnaires des caracteristiques des
   categories flechies */
struct DicoTraitsCatLex
{
    ChIdent                    ChaineDico;
    int                        TypeDico;
    int                        NbFlexions;
    int                        NbDerivations;
    int                        NbNoTypeFlexion;
    int                        NbNoTypeDerivation;
    int                        RangPremSuffixeFlexion;
    int                        RangPremSuffixeDerivation;
    int                        RangPremDagFlexion;
    int                        RangPremDagDerivation;
    int                        Indice;
    struct DicoTraitsCatLex   *Suivant;
};

struct EntreeDicoConversion
{
    char       chIni[_MaxLetDicoEnum];
    char       chACG[_MaxLetDicoEnum];
};

/*************************************************************************
                            LES SUFFIXES
*************************************************************************/
/* les suffixes des flexions des adjectifs, noms et verbes                  */
struct Suffixe
{
        char                    Suff[_TailSuffixage];
};
/* un noeud de graphe de suffixes permettant de construire l'automate de
    reconnaissance des suffixes dans un mot flechi ecrit a l'envers         */
struct UnNoeudSuff
{
    char                        Car;
    char                        NbFils;
    char                        Terminal;
    struct UnNoeudSuff          *PtFils;
};

/*************************************************************************
                            LE B_ARBRE
*************************************************************************/
/* "porte" du B_Arbre de niveau median                                      */
struct PorteNormale
{
        char    ChaineBAr[_NbMaxLetBArb]; /* un code de 4 caracteres        */
        char    IndCar;                /* Numero de debut du classement
                                          alphabetique au rang superieur    */
};
/* "porte" du B_Arbre de niveau superieur                                   */
struct PorteSuperieure
{
        long    PosFicLemme;  /* un pointeur vers un Lemme         */
        char    ChaineBAr[_NbMaxLetBArb]; /* 4 caracteres discriminatifs.   */
        char    IndCar;                /* Numero de debut du classement     */
};

/*************************************************************************
            TYPES MEMOIRE (DAGS)
*************************************************************************/
struct OperLogMem
{
    char                   Oper;                             /* & | = ! */

    char                   TypeFils1;            /* _Arc -> hdlPereChemin */
    char                   TypeFils2;            /* _Atome -> ptPereAtome */

    union
    {
    TabDagMem              ptPereAtome;
    TabDagMem             *hdlPereChemin;
    }                      Fils1;
    union
    {
    TabDagMem              ptPereAtome;
    TabDagMem             *hdlPereChemin;
    }                      Fils2;
};

struct ArcMem
{
    char                   ArcERNegation;
    char                   ValMin;
    char                   ValMax;
    char                   Comptage;
    ChIdent                Ident;
    long                   ValSymb;
    long                   ValRef;
};

struct ValAtomeMem
{
    char                   AtomeConjDisj;
    union
    {
    long                   Entier;
    long                   Ref;
    ChIdent                Chaine;
    }                      ValAtome;
};

union ValueDag
{
  struct ValAtomeMem     Atome;
  struct ArcMem          Arc;
  struct OperLogMem      OperLog;
};

struct DagMem
{
    char                   TypeDag;
    char                   Marque;

    union ValueDag         ValDag;

    TabDagMem              Frere;
    TabDagMem              Fils;
};

/*************************************************************************
            TYPES MEMOIRE (ARBRES)
*************************************************************************/
struct ValTerme
{
    ChIdent                Ident;
    long                   Ref;
    long                   RefRacine;
    TabRefPhraseMem        RefSemantique;
    TabRefPhraseMem        RefSelf;
    char                   TypeTerme;
    TabDagMem              ArcsFils;
    long                   PosFicRegle;
};

struct LemmeMem
{
    struct ValTerme        ValTerme;

    int                    NbRegles;
    int                    NbDerives;
    int                    NbVoisinsSemantiques;
    int                    NbVoisinsSemantiquesRec;
    long                   PosFicDerives;
    long                   PosFicRacine;
    long                   PosFicLiensSemantiques;
    long                   PosFicLiensSemantiquesRec;

    TabLemmeMem            LemmeFrere;
};

struct TermeMem
{
    struct ValTerme        ValTerme;

    TabTermeMem            TermeFils;
    TabTermeMem            TermeFrere;
};

struct RegleMem
{
    TabTermeMem            TermeFils;
    TabRegleMem            RegleFrere;

    TabTermeMem            Transformee;
    int                    TransformeeAvecUnificationExterne;
    long                   PosFicRegleSuivante;
};

struct RegleMemMeta
{
    int                    NoTableau;
    int                    AvecUnificationExterne;

    TabTermeMem            TermeFils;
    TabRegleMemMeta        RegleFrere;
};

struct TeteRegleMeta
{
    TabRegleMemMeta        PtRegleMeta;
    ChIdent                Ident;
};

/*************************************************************************
        LE DICTIONNAIRE DES MOTS COURTS OU USUELS
*************************************************************************/
/* Une entree du dictionnaire des mots courts ou usuels                     */
struct EntreeDucs
{
        struct EntreeDucs     *Suivant;
        struct LemmeMem       Lemme;
};

/*************************************************************************
                          MOTS DE LA PHRASE
*************************************************************************/
struct MotMem
{
        ChMot               ChaineMot;
        char                Forme;
        TabLemmeMem         PtListeLemmes;
        TabDagMem           ArcsFils;

        TabMotMem           MotFrere;
};

/*************************************************************************
     MEMOIRES DE NOEUDS DE DAG EN UNIFICATION POUR MODIFIER LES ADRESSES
                       POINTANT VERS LES NOEUDS JETES
*************************************************************************/
struct NoeudSauve
{
    TabDagMem              PtNoeudAnc;       /* le noeud intial          */
    TabDagMem              PtNoeudNouv;      /* le noeud de substitution */
};

/*************************************************************************
     CORRESPONDANCE ENTRE UN POINTEUR FICHIER ET NO DE VARIABLE
           UTILISE EN SAISIE DE DAG OU EN AFFICHAGE DE DAG
*************************************************************************/
struct LienMemVar
{
    int                    NbRef;      /* nb de dag le refrencant       */
    char                   NoVar;      /* un No de variable             */
    char                   Ecrit;      /* boolean de memoire d'ecriture */
    TabDagMem              PtMem;      /* le pointeur fichier           */
};

/*************************************************************************
       STRUCTURE POUR LA RECHERCHE RAPIDE D'UN IDENTIFICATEUR DE REGLE
                   LORS DE L'ECRITURE DES RESULTATS D'ANALYSE
*************************************************************************/
struct CorrIdent_PosFic
{
    long                  RefIdent;        /* ref de l'identificateur  */
    long                  PosFicIdent;     /* position dans le fichier */
};

/*************************************************************************
                 STRUCTURES POUR L'EFFACEMENT DES REGLES
*************************************************************************/

/* premiere partie du bloc servant a empiler les termes effaces */
struct BlocInitial
{
    unsigned long    ptBlocSuivant,       /* gestion du chanage des blocs       */
                     ptBlocPrecedent,
                     ptBlocPere;

    /* pointeur servant a anvrer le dag recoppie du terme courant   */
    TabDagMem        dagCopie;

    char             typeBloc;        /* caracteristiques du bloc courant    */
    char             noChoix,
                     nbChoix;
    char             bidon;

                                      /* environnement sauve en effacement   */
    int              indiceMotCou;    /* et restaure en backtracking         */
    int              debutMotsReconnusCou; 
    int              finMotsReconnusCou; 
    TabChar          ptSauve1;        /* pointeurs modifies pour le chainage */
                                      /* de l'arbre d'analyse & sauves ici   */

    union                             /* le premier terme recopie : T1       */
    {
       TabRegleMem    PtRegle;
       TabTermeMem    PtTerme;
       TabLemmeMem    PtLemme;
    } T1;
};

struct LemmesMots
{
    TabLemmeMem     PtLemme;
    int             IndMot;
    int             IndDebutER;
    int             IndFinER;
};

/*****************************************************************************
         LIEN ENTRE UN IDENTIFICATEUR ET L'ADRESSE D'UN TERME
*****************************************************************************/
struct UnLienIdentTerme
{
     ChIdent                       Ident;
     struct ValTerme              *PtValTerme;
     TabTermeMem                   PtTerme;
};

/*****************************************************************************
         LIEN ENTRE UN IDENTIFICATEUR DE TERME ET SA CHAINE
*****************************************************************************/
struct ChaineTerme
{
     char         ident[ _MaxLetIdent + 1 ]; 
     TabChar      chaine;
};

/*****************************************************************************
          types de donnees utilises en analyse des boucles dans les ER
*****************************************************************************/
struct CaracBouc
{
     char              Min;
     char              Max;
     char              NbFaites;
};

/*************************************************************************
   VARIABLES & CONSTANTES INTERNES DE GESTION DES LIENS ENTRE TERMES
*************************************************************************/
#define           _Ecrit        2
struct Lien
{
     long         idTermeIni;
     long         idTermeAcquis;
     char         variation;
     char         etapeAcquisition;
     char         parcouru;
     char         aLEndroit;
};
struct SequenceDeLiens
{
     struct Lien             *lien;
     struct SequenceDeLiens  *lienSui;
};
struct TermedeLien
{
     long         id;
     char         connuAEtape;   /* etape ou le terme a ete decouvert */
                                 /* O : inconnu, 1 : initial, i>1 : etape i */
};

/*************************************************************************
      STOCKAGE DES REFERENCES DANS LE CAS DE REFERENCES MULTIPLES :
      DISJONCTIONS SUR SELF OU SUR LES TRAITS SEMANTIQUES
*************************************************************************/
struct RefPhraseMem
{
     long                 Ref;
     TabRefPhraseMem      Suivant;
};

/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
            fin de al-ext.h
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
