/*
 * FASt Term Recognizer
 *
 *  FASTR/al-fic.h
 *  Version 2.04/04-02-01
 *
 *  Copyright (C) 2004  Christian Jacquemin, LIMSI-CNRS
 *
 *  This file contains file data structures
 */

#define    _RefEnAvant              1
#define    _RefEnArriere            2

#ifdef PCold
typedef struct DagFic huge                    *TabDagFic;
typedef struct LemmeFic huge                  *TabLemmeFic;
typedef struct TermeFic huge                  *TabTermeFic;
typedef struct RegleFic huge                  *TabRegleFic;
#else
typedef struct DagFic                         *TabDagFic;
typedef struct LemmeFic                       *TabLemmeFic;
typedef struct TermeFic                       *TabTermeFic;
typedef struct RegleFic                       *TabRegleFic;
#endif

/*************************************************************************
            TYPES FICHIER (DAGS)
*************************************************************************/
struct OperLogFic
{
    char                   Oper;                             /* & | = ! */

    char                   TypeFils1;            /* _Arc -> hdlPereChemin */
    char                   TypeFils2;            /* _Atome -> ptPereAtome */

    char                   x1;

    union
    {
    long                   ptPereAtome;
    long                   hdlPereChemin;
    }                      Fils1;
    union
    {
    long                   ptPereAtome;
    long                   hdlPereChemin;
    }                      Fils2;
};

struct ArcFic
{
    long                   ValSymb;
};

struct ValAtomeFic
{
    int                    AtomeConjDisj;
    union
    {
    long                   Entier;
    long                   Ref;
    long                   LongChaine;
    }                      ValAtome;
};

struct DagFic
{
    union
    {
    struct ValAtomeFic     Atome;
    struct ArcFic          Arc;
    }                      ValDag;

    char                   TypeDagFic;
    char                   Frere;
    char                   Fils;

    char                   x1;
};

/*************************************************************************
            TYPES FICHIER (ARBRES)
*************************************************************************/
struct LemmeFic
{
    long                   Ref;
    long                   RefRacine;
    long                   PosFicRegle;

    int                    NbRegles;
    int                    NbDerives;
    int                    NbVoisinsSemantiques;
    int                    NbVoisinsSemantiquesRec;

    long                   PosFicDerives;
    long                   PosFicRacine;
    long                   PosFicLiensSemantiques;
    long                   PosFicLiensSemantiquesRec;
    long                   RegleFils;
 
    char                   ArcsFils;
    char                   x1;
    char                   x2;
    char                   x3;
};

struct TermeFic
{
    long                   Ref;
    long                   RefRacine;

    char                   TypeTerme;
    char                   TermeFils;
    char                   TermeFrere;
    char                   ArcsFils;

    long                   PosFicRegle;
};

struct RegleFic
{
    char                   TermeFils;
    char                   x1;
    char                   x2;
    char                   x3;

    long                   PosFicRegleSuivante;
};

/*************************************************************************
     CORRESPONDANCE ENTRE UN POINTEUR FICHIER ET UN POINTEUR DE DAG
    POUR LES POINTAGES MULTIPLES LORS DES PASSAGES MEMOIRE / FICHIER
*************************************************************************/
struct LienMemFic
{
    long                   PtFic;      /* son pointeur fichier relatif */
    TabDagMem              PtMem;      /* le noeud memoire     */
};

/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
            fin de al-fic.h
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
