/*
 * FASt Term Recognizer
 *
 *  FASTR/al-var.h
 *  Version 2.04/04-02-01
 *
 *  Copyright (C) 2004  Christian Jacquemin, LIMSI-CNRS
 *
 *  This file contains external variables
 */

/************************************************************************
                VARIABLES EXTERNES
*************************************************************************/

/*************************************************************************
                  ALLOCATIONS DYNAMIQUES DE TERMES
*************************************************************************/
                                       /* les mots reconnus de la phrase  */
extern int                         NbMots;
extern TabMotMem                   MotsPhrase;

extern long                        NbLignesTot;

extern TabMotMem                   PremierMotLibre;
extern TabRefPhraseMem             PremierRefPhraseLibre;
extern TabLemmeMem                 PremierLemmeLibre;
extern TabTermeMem                 PremierTermeLibre;
extern TabDagMem                   PremierDagLibre;
extern TabRegleMemMeta             PremierRegleLibreMeta;
extern TabRegleMem                 PremiereRegleLibre;

extern TabRegleMem                 ReglesMem;
extern int                         NbReglesMem;

extern TabLiensIdentTerme          LienIdentTerme;     
                                       /* lien entre ident et terme en compil*/
extern int                         NbLiensIdentTerme;

extern TabLienMemFic               LiensNoeudsMemFic;    
                                       /* lien entre adresse mem et ptfic  */
extern int                         NbLiensNoeudsMemFic;  
                                       /* nbr liens dags mem / fichier     */

extern TabLienMemVar               LiensNoeudsMemVar;    
                                       /* lien pt noeuds et No de variable */
extern int                         NbLiensNoeudsMemVar;  
                                       /* utilise en affich et lecture dag */

extern TabNoeudSauve               LiensNoeudsCopies;    
                                       /* lien pt noeuds et noeuds copies */
extern int                         NbLiensNoeudsCopies;  
                                       /* utilise en copie de dags et arbres */

extern int                         DebutMotsReconnus;        
extern int                         FinMotsReconnus;        
                                       /* utilise fin d'analyse avant affic */

extern TabCaracBouc                TBoucEnCours;         
                                       /* boucle en cours ds 1 anal d'ER */
extern int                         NbBoucEnCours;        
                                       /* nb de boucles imbr en cours    */

/*****************************************************************************
    LA GESTION DES POINTEURS VERS LES DAGS SUPPRIMES PAR UNIFICATION
*****************************************************************************/
extern TabDagMem                   PtDagJeteU;           
                                /* un dag jete par unification   */
extern TabDagMem                   PtDagGardeU;          
                                /* le dag conserve a la place de PtDagGardeU */
extern int                         NbRestaurationsU;     
                                /* nb de m a j de PtDagJeteU en PtDagGardeU */
extern TabDagMem                   PtOperLogU;           
                                /* liste des operations d'unif a faire */
extern TabDagMem                  *HdlDagU;              
                                /* dags sur lesquels porte l'unif */
extern TabTermeMem                *HdlTermeU;            
                                /* arbre des termes portant les dags unifies */
extern TabBlocInitial              PtBlocU;              
                                /* liste des blocs portant les dags unifies */

/*****************************************************************************
               LE TEXTE LU
*****************************************************************************/
/* 1:le buffer du texte lu                                                  */
/* 2:indice du caractere du fichier texte dans le buffer ( indice relatif ) */
extern char                        *BuffTexte;
extern char                        *BuffSortie;
extern int                         EstEntreeSortieBuffer;
extern long                        IndCar;
extern long                        IndCarM;
extern long                        IndCarSortieM;

/*************************************************************************
                LE DICTIONNAIRE DE TRANSFERT DES CATEGORIES EN
                       GENERATION AUTOMATIQUE DE REGLES
*************************************************************************/
/**                 variable garnie dans le set up                    **/
/* struct EntreeDicoConversion                DicoTransfert[ _DerCatLex + 2 ];*/

/*************************************************************************
                             LE BARBRE
*************************************************************************/
extern long                       *TPremIndB_Arb;  
                        /* indice de chaque niveau du BArb */
extern long                       *TNbTermesB_Arb; 
                        /* nombre de termes de chaque niveau du BArbre */

extern TabPorteSuperieure          B_ArbSup;
extern TabPorteNormale             B_ArbInf;
extern ChIdent                     DernLemme;
extern ChIdent                     PremLemme;

extern int                         ProfondeurBArbre; 
                        /* nombre de niveaux du B-Arbre */
extern int                         NbPortesBArbre;   
                        /* nombre de portes a chaque noeud du B-Arbre */
extern long                        FrequenceMAJBArbre; 
                        /* intervalle de remise a jour du B-Arbre en compil */
extern long                        TailleBArbInf;
extern long                        TailleBArbSup;

/*************************************************************************
                             DIVERS
*************************************************************************/
extern TabRegleMem                 ReglesPhrase;       
                                       /* les regles des mots reconnus       */
extern struct TeteRegleMeta        Tableaux[ _NbMaxTableau ]; 
                                       /* les tableaux de metaregles */
extern FILE                        *PtFicRegles;

extern char                        Reponses[ 2 * (_NbLigneEcran - 6) ];
extern char                        Rubriques[ 2 * (_NbLigneEcran - 6) ] 
                                            [ _NbLColEcran ];
extern char                        Titre[ 256 ];

/*************************************************************************
                             ECRITURE
*************************************************************************/
extern int                             LieuDAffichage;
extern FILE                           *FichierDAffichage;

/*************************************************************************
                       DICTIONNAIRE BINAIRE
*************************************************************************/
/* gestion du fichier de stockage des caracteristiques des
   elements lexicaux */
/* 1 : le fichier */
/* 2 : l'indice absolu minimal et maximal dans le buffer
   (en dehors desquels il faut aller se servir dans le fichier pour trouver
   l'element). les indices minimaux servent a deduire l'indice relatif en les
   soustrayant a l'indice absolu */
extern FILE                       *FicBDicRegles;
extern FILE                       *FicBDicLemmes;
extern FILE                       *FicBDicLiens;
extern FILE                       *FicBDicLiensAux;
extern unsigned long               IndBuffLemmeMin;
extern unsigned long               IndBuffLemmeMax;
extern unsigned long               IndBuffRegleMin;
extern unsigned long               IndBuffRegleMax;
extern char                        NomFicDico[ _NbMaxLetNomFic ];
extern char                        NomFicMessages[ _NbMaxLetNomFic ];
extern char                        NomFicExtUnifier[ _NbMaxLetNomFic ];
extern char                        NomFicUnification[ _NbMaxLetNomFic ];
extern char                        NomFicAux[ _NbMaxLetNomFic ];
extern FILE                       *FicUnification;

/* un buffer pour relever une unite lexicale + regles en une seule lecture */
extern TabChar                     BufferLemmesCourant;
extern TabChar                     BufferReglesCourant;
extern TabChar                     BufferLemmesCourt;
extern TabChar                     BufferReglesCourt;
extern TabChar                     BufferLemmesLong;
extern TabChar                     BufferReglesLong;
extern TabChar                     BufferLiensMorphologiquesEtSemantiques;
extern long                        TailleBuffStd;     
                                       /* taille buffer d'ES stdrd (txt)    */
extern long                        TailleBuffLemmesCourt;  
                                       /* taille buffer d'ES stdrd (lemmes) */
extern long                        TailleBuffReglesCourt;  
                                       /* taille buffer d'ES stdrd (regles) */
extern long                        TailleBuffLemmesLong;  
                                       /* taille buffer d'ES stdrd (lemmes) */
extern long                        TailleBuffReglesLong;  
                                       /* taille buffer d'ES stdrd (regles) */
extern long                        TailleBuffLemmesCourant;  
                                       /* taille buffer d'ES en cours(lemmes)*/
extern long                        TailleBuffReglesCourant;  
                                       /* taille buffer d'ES en cours(regles)*/
extern int                         BDicSurDisque;   
                                       /* booleen faux en cas de chrgt
                                          du dico en memoire */
extern int                         BDicReduit;  
                                       /* dictionnaire ou sont
                                          supprimes les chemins lemma
                                          et inflection */

/*************************************************************************
        LE DICTIONNAIRE DES MOTS COURTS OU USUELS
*************************************************************************/
extern struct EntreeDucs           *Ducs;

/*************************************************************************
                FICHIER GLOBAUX ET BOOLEENS DE SETUP
*************************************************************************/
extern ChIdent                     Versionfastr;      /* version of fastr */
extern ChIdent                     Datefastr;         /* date of fastr */
extern char                        NomFicLog[ _NbMaxLetNomFic ];
extern char                        NomFicHeader[ _NbMaxLetNomFic ];
extern FILE                       *FicBufferiseCourant; 
                           /* fichier d'entree bufferise*/
extern FILE                       *FicLog;     
                           /* fichier des messages       */
extern FILE                       *FicRefIdent;    
                           /* fichier table des identificateurs de
                              regles + ref */
extern FILE                       *FicRefMots;     
                           /* fichier table des mots + ref */
extern int                         VerificationAccord;
extern int                         PretraitementDesNombres;
extern int                         OuvreAutomMetaregl;
extern int                         OuvreAutomReglesMem;
extern int                         AriteMin;  
                           /* arite en-dessous de laquelle les regles
                              ne sont pas tenteees */
extern int                         AriteMax;  
                           /* arite au-dessus de laquelle les regles
                              ne sont pas tenteees */
extern int                         FormatDEntree;  
                           /* type des donnees en indexation */
extern int                         FormatDeSortie;  
                           /* type des donnees en indexation */
extern int                         TraceTexteEnSortie; 
                           /* ecriture du texte lu en analyse */
extern int                         HeaderEnSortie; 
                           /* ecriture du texte lu en analyse */
extern long                        NoPremLigne;  
                           /* no de la premiere notice en sortie Inist */
extern int                         ArretSurErreurCompil;
extern int                         ClasstReglesAutom;  
                           /* resequentialisation autom. des regles en
                              fin de compil */
extern int                         LinkAutom;  
                           /* ed autom de liens en fin de compil */
extern int                         LexicalisationMultiple;  
                           /* lexicalisation autom d'1 regle sur ses lemmes */
extern int                         TraitementBatch;  
                           /* insertion dans un shell */
extern int                         MinusculisationAutomatique;  
                           /* Passage automatique en minuscules */
extern int                         SegmentationAutomatique;  
                           /* Segmentation automatique des mots */
extern int                         LexicalisationImperativeDesRegles;
extern int                         AutomaticSelfMorphologicalRoot;  
                           /* automatic addition of morph. root <self> */
extern int                         AutomaticSelfSemanticLinks;  
                           /* automatic addition of semantic links to <self> */
extern char                        ChErreurCompil[ 2048 ];
extern char                        ChAux[ 2048 ];
extern int                         Trace;

/*************************************************************************
                            VARIABLES D'ANALYSE
*************************************************************************/
/* un indice, indiquant eventuellement l'indice du mot courant de la
  la sequence en cours de reconnaissance                               */
extern int                         IndiceMotCou;

/* la pile d'effacement avec son pointeur et l'indice de haut de pile  */
extern TabChar                     Pile;
extern unsigned long               HautPile;
extern unsigned long               TaillePileEffacement;

extern int                         NbMaxGenerations;

/*************************************************************************
            VARIABLES GLOBALES POUR LA GESTION DES FLEXIONS
*************************************************************************/
/**    LISTES DE SUFFIXES A AJOUTER AUX RACINES POUR AVOIR LES FLEXIONS    **/
extern struct UnNoeudSuff          NoeudsSuff[ _NbMaxNoeudsSuffixe ];
extern int                         NbNoeudsSuff;    /* prochainn noeud a allouer   */
/**        LES SUFFIXES PREDEFINIS                                         **/
extern struct Suffixe              *Suffixes;

/**        LE DICTIONNAIRE DE TRAITS ET CATEGORIES LEXICALES           **/
extern TabDicoTraitsCatLex         DicoTraitsCatLex;

/**        LES CHEMINS PREDEFINIS                                      **/
extern TabDagMem                   CheminCategorie;
extern TabDagMem                   CheminEtiquette;
extern TabDagMem                   CheminRacinesAnnexes;
extern TabDagMem                   CheminLexicalisation;
extern TabDagMem                   CheminLemme;
extern TabDagMem                   CheminFlexion;
extern TabDagMem                   CheminDerivation;
extern TabDagMem                   CheminForme;
extern TabDagMem                   CheminNombre;
extern TabDagMem                   CheminReference;
extern TabDagMem                   CheminEtiquetteMeta;
extern TabDagMem                   CheminRacine;
extern TabDagMem                   CheminLeadingExprReg;
extern TabDagMem                   CheminTrailingExprReg;
extern TabDagMem                   CheminsSemantique[ _NbMaxTypesLiensSem ];
extern TabDagMem                   CheminSelf;

/**        LES CATEGORIES PREDEFINIES                                  **/
extern long                        RefCatMotsInc;
extern long                        RefDeterminantNumeral;
extern long                        RefPonctuation;
extern long                        RefPonctuationFinale;

/**        LES CATEGORIES A DISTINGUER EN MORPHO ROBUSTE               **/
extern long                        RefMajorCategories[ _MaxMajorCategories ];
extern int                         NbMajorCategories;
extern long                        RefCatLexVide; /* la val de la cat lex vide X */

/**        LES ATOMES PREDEFINIS                                       **/
extern long                        RefSingulier;
extern long                        RefPluriel;

/**        LES FLEXIONS PREDEFINES                                     **/
extern TabDagMem                   TabDagsSuffixage[ _NbMaxSuffixages ];
extern TabDagMem                   TabListeMetaReglesStd[ _NbMaxTableau ];

/**        LES CARACTERES SPECIAUX                                     **/
extern char                        CarSpeciauxMots[ _MaxCarSpeciaux ];
extern char                        Ponctuation[ _MaxCarSpeciaux ];
extern char                        PonctuationFinale[ _MaxCarSpeciaux ];

/*************************************************************************
                              tailles des tableaux
*************************************************************************/
extern long                        NbMaxElemAllouables[ _DerTypeElemAllouable ];
extern int                         NbReallocations[ _DerTypeElemAllouable ];

extern int                         NbMaxReglesMem;  
                           /* nb max de regles memoire          */

extern int                         NbMaxLiensMemorises; 
                           /* nb max de liens memorises     */

extern int                         NbMaxTraitsCatLex; 
                           /* n max d'ident de cat lex ou traits*/
extern int                         NbMaxSuffixes;     
                           /* nb max de suffixes de mots simples*/
extern int                         NbMaxTermesDansUneRegle; 
                           /* nb max de termes dans une regle (pour
                              ref dans chemins) */
extern int                         NbMaxChainesTermes;
                           /* nb max de chaines de termes ds la liste
                              de reference*/
extern int                         NbMaxLiens;        
                           /* nb max de liens acquis par var. */

/*************************************************************************
        VARIABLES GLOBALES DE LA MORPHOLOGIE
*************************************************************************/
extern int                         SuffStripping;     
                           /* suppression uniforme des suffixes */
extern int                         TailSuffStripping; 
                           /* taille de la suppression uniforme des suffixes */
extern int                         MorphoFlex;     
                           /* morphologie flexionnelle interne */
extern int                         MorphoDer;     
                           /* morphologie derivationnelle interne */
extern int                         ExploitationLiensMorpho;     
                           /* exploitation des liens morphologiques compiles */
extern int                         ExploitationLiensSem;     
                           /* exploitation des liens semantiques compiles */

/*************************************************************************
        VARIABLES GLOBALES DU LANGAGE
*************************************************************************/
#ifdef PCold
extern unsigned             _stklen = (unsigned)(1024 * 20);
              /* PC taille de la pile d'execution */
#endif

