/*
 * FASt Term Recognizer
 *
 *  FASTR/albase.c
 *  Version 2.04/04-02-01
 *
 *  Copyright (C) 2004  Christian Jacquemin, LIMSI-CNRS
 *
 *  This file contains code for initializations
 */

#include "unistd.h"
#include "al-ext.h"
#include "al-var.h"
#include "al-car.h"
#include "al-fic.h"
#include "al-path.h"

#ifndef WARNINGS
#include "al-head.h"
#endif
#ifdef WARNINGS
#include "al-headP.h"
#endif

/*************************************************************************
                  EXTERNAL VARIABLES
*************************************************************************/
extern char               **environ;

/*****************************************************************************
            code ascii personalise commun a toutes les machines
*****************************************************************************/
char     Ascii( int c )
{
/*    if((char)c >= '0' && (char)c<= 'a') { return (char)c; } */
/*    if((char)c > 'a' && (char)c <= 'c') { return (char)(c + 6); } */
/*    if((char)c > 'c' && (char)c <= 'e') { return (char)(c + 7); } */
/*    if((char)c > 'e' && (char)c <= 'i') { return (char)(c + 11); } */
/*    if((char)c > 'i' && (char)c <= 'n') { return (char)(c + 15); } */
/*    if((char)c == 'o')            { return (char)(c + 16); } */
/*    if((char)c > 'o' && (char)c <= 'u') { return (char)(c + 21); } */
/*    if((char)c > 'u' && (char)c <= 'z') { return (char)(c + 25); } */
/*    if(c == _SonAGrav) { return (char)_MonAGrav; } */
/*    if(c == _SonACirc) { return (char)_MonACirc; } */
/*    if(c == _SonATrem) { return (char)_MonATrem; } */
/*    if(c == _SonCCedi) { return (char)_MonCCedi; } */
/*    if(c == _SonEAigu) { return (char)_MonEAigu; } */
/*    if(c == _SonEGrav) { return (char)_MonEGrav; } */
/*    if(c == _SonECirc) { return (char)_MonECirc; } */
/*    if(c == _SonETrem) { return (char)_MonETrem; } */
/*    if(c == _SonICirc) { return (char)_MonICirc; } */
/*    if(c == _SonITrem) { return (char)_MonITrem; } */
/*    if(c == _SonOCirc) { return (char)_MonOCirc; } */
/*    if(c == _SonOTrem) { return (char)_MonOTrem; } */
/*    if(c == _SonUGrav) { return (char)_MonUGrav; } */
/*    if(c == _SonUCirc) { return (char)_MonUCirc; } */
/*    if(c == _SonUTrem) { return (char)_MonUTrem; } */
   return c;
}

/****************************************************************************
    Allocation de tableau de caracteres de taille standard
    le double de la taille maximale autorisee par securite
*****************************************************************************/
TabChar  AlloueBuffer( long p_taille )
{
   TabChar             resul;
   unsigned long       taille;

   taille = (unsigned long)sizeof(char) * (unsigned long)( 2L * p_taille );
   resul = (TabChar)_Alloc(taille);


   if ( !resul )
   {
       TxtErreur( 81 , "AlloueBuffer(albase)" );
       exit(0);
   }

   return resul;
}

/*****************************************************************************
                        reservation de place memoire (projet 1 et 2)
*****************************************************************************/
void     IniGrandsTableaux( int p_afficheTaillesSansAllouer )
{
    long               tailTot;
    long               tailBuffTxt;
    long               tailBuffLemmes;
    long               tailBuffRegles;
    long               tailLiensNoeudsMemFic;
    long               tailLiensNoeudsMemVar;
    long               tailLiensNoeudsCopies;
    long               tailTBoucEnCours;
    long               tailBARSup;
    long               tailBArInf;
    long               tailDucs;
    long               tailSuffixes;
    long               tailDicoTraitsCatLex;
    long               tailReglesMem;
    long               tailLiensIdentTerme;
    long               tailPile;
    long               noTableau;
    long               indLemme;

    tailLiensNoeudsMemFic = (unsigned long) sizeof( struct LienMemFic )
                * (unsigned long) NbMaxLiensMemorises;
    tailLiensNoeudsMemVar = (unsigned long) sizeof( struct LienMemVar )
                * (unsigned long) NbMaxLiensMemorises;
    tailLiensNoeudsCopies = (unsigned long) sizeof( struct NoeudSauve )
                * (unsigned long) NbMaxLiensMemorises;
    tailTBoucEnCours = (unsigned long) sizeof( struct CaracBouc )
                * (unsigned long) _MaxBoucEnCours;
    tailBARSup = (unsigned long) sizeof( struct PorteSuperieure )
                        * (unsigned long) TailleBArbSup;
    tailBArInf = (unsigned long) sizeof( struct PorteNormale )
                        *(unsigned long) TailleBArbInf;
    tailDucs = (unsigned long) sizeof( struct EntreeDucs )
                            * (unsigned long) (_TailDucs + 1);
    tailSuffixes = (unsigned long) sizeof( struct Suffixe )
                        * (unsigned long) ( NbMaxSuffixes  + 1);
    tailDicoTraitsCatLex = (unsigned long) sizeof( struct DicoTraitsCatLex )
                        * (unsigned long) (NbMaxTraitsCatLex + 1);
    tailReglesMem = (unsigned long) sizeof( struct RegleMem )
                        * (unsigned long) NbMaxReglesMem;
    tailLiensIdentTerme = (unsigned long) sizeof( struct UnLienIdentTerme )
                        * (unsigned long) (NbMaxTermesDansUneRegle + 1);
    tailBuffTxt = (unsigned long)2L * (unsigned long)TailleBuffStd;
    tailBuffLemmes = (unsigned long)2L * (unsigned long)TailleBuffLemmesCourt;
    tailBuffRegles = (unsigned long)2L * (unsigned long)TailleBuffReglesCourt;
    tailPile = (unsigned long)TaillePileEffacement;

    tailTot = 0L
#ifdef PCold
         + (unsigned long)(_stklen)
#endif
        + tailLiensNoeudsMemFic 
        + tailLiensNoeudsMemVar + tailLiensNoeudsCopies 
        + tailTBoucEnCours + tailBARSup + tailBArInf + tailDucs
        + tailSuffixes + tailDicoTraitsCatLex + tailReglesMem 
        + tailLiensIdentTerme
        + tailBuffTxt + tailBuffLemmes + tailBuffRegles 
        + tailPile;

    if( p_afficheTaillesSansAllouer )
    {
        _Cs();

        printf( "Taille totale de l'initialisation %d kO\n",
                  (int)(tailTot >> 10));
#ifdef PCold
        printf( "Taille de la pile %5d kO\n",(int)(_stklen >> 10));
#endif

        printf("\nTaille detaillee de l'initialisation : \n");

        printf(  "4 buffers I/O + Pile : %5d kO \n" , 
                        (int)((tailBuffTxt + tailBuffLemmes + tailBuffRegles 
                               + tailPile ) >> 10));
        printf( "Sauve noeuds modif   : %5d kO \n" , 
                        (int)(tailLiensNoeudsMemFic >> 10));
        printf( "Sauve noeuds affich  : %5d kO \n" , 
                        (int)(tailLiensNoeudsMemVar >> 10));
        printf( "Sauve noeuds copies  : %5d kO \n" , 
                        (int)(tailLiensNoeudsCopies >> 10));
        printf( "Boucles d'ER en cours: %5d kO \n" , 
                        (int)(tailTBoucEnCours >> 10));
        printf( "B Arbre superieur    : %5d kO \n" , 
                        (int)(tailBARSup >> 10));
        printf( "B Arbre inferieur    : %5d kO \n" , 
                        (int)(tailBArInf >> 10));
        printf( "Dico mots simples    : %5d kO \n" , 
                        (int)(tailDucs >> 10));
        printf( "Suffixes             : %5d kO \n" , 
                        (int)(tailSuffixes >> 10));
        printf( "Dico categ lexicales : %5d kO \n" , 
                        (int)(tailDicoTraitsCatLex >> 10));
        printf( "Regles memoire       : %5d kO \n" , 
                        (int)(tailReglesMem >> 10));
        printf( "Liens compilation    : %5d kO \n" , 
                        (int)(tailLiensIdentTerme >> 10));
	if( !TraitementBatch ) {
	  TxtAttente();
	}
   }
   else {
     LiensNoeudsMemFic = (TabLienMemFic)_Alloc( tailLiensNoeudsMemFic );
     LiensNoeudsMemVar = (TabLienMemVar)_Alloc( tailLiensNoeudsMemVar );
     LiensNoeudsCopies = (TabNoeudSauve)_Alloc( tailLiensNoeudsCopies );
     TBoucEnCours = (TabCaracBouc)_Alloc( tailTBoucEnCours );
     B_ArbSup = (TabPorteSuperieure)_Alloc( tailBARSup );
     B_ArbInf = (TabPorteNormale)_Alloc( tailBArInf );
     Ducs = (struct EntreeDucs *)_Alloc( tailDucs );
     Suffixes = (struct Suffixe *)_Alloc( tailSuffixes );
     DicoTraitsCatLex = (TabDicoTraitsCatLex)_Alloc( tailDicoTraitsCatLex );
     ReglesMem = (TabRegleMem)_Alloc( tailReglesMem );
     LienIdentTerme = (TabLiensIdentTerme)_Alloc( tailLiensIdentTerme );
     BuffTexte = AlloueBuffer( tailBuffTxt );
     BuffSortie = AlloueBuffer( tailBuffTxt );
     BufferLemmesCourt = AlloueBuffer( (unsigned long)TailleBuffLemmesCourt );
     BufferReglesCourt = AlloueBuffer( (unsigned long)TailleBuffReglesCourt );
     Pile = (TabChar)_Alloc( (unsigned long)(TaillePileEffacement));

   /* sont initialises apres ouverture des dicos */
   /* dependent de la taill des dicos dans le cas de dicos memoire */
     BufferLemmesCourant = BufferLemmesCourt;
     TailleBuffLemmesCourant = TailleBuffLemmesCourt;
     BufferReglesCourant = BufferReglesCourt;
     TailleBuffReglesCourant = TailleBuffReglesCourt;
     BufferLemmesLong = NULL;
     TailleBuffLemmesLong = 0L;
     BufferReglesLong = NULL;
     TailleBuffReglesLong = 0L;

     if ( !LiensNoeudsMemFic || !LiensNoeudsMemVar 
	  || !LiensNoeudsCopies || !TBoucEnCours 
	  || !B_ArbSup || !B_ArbInf || !Ducs
	  || !Suffixes || !DicoTraitsCatLex || !ReglesMem || !LienIdentTerme
	  || !BuffTexte || !BuffSortie 
	  || !BufferLemmesCourt || !BufferReglesCourt 
	  || !Pile )
       {
	 TxtErreur( 18 , "IniGrandsTableaux(albase)" );
	 exit(0);
       }
   }

    /* initialisation du tableau des metaregles */
    for( noTableau = 0 ; noTableau < _NbMaxTableau ; noTableau++ )
    {
          Tableaux[ noTableau ].PtRegleMeta = NULL;
          *(Tableaux[ noTableau ].Ident) = '\0';
    }
    for( noTableau = 0 ; noTableau < _NbMaxTableau ; noTableau++ )
    {
          Tableaux[ noTableau ].PtRegleMeta = NULL;
          *(Tableaux[ noTableau ].Ident) = '\0';
    }
    for( indLemme = 0 ; indLemme < _TailDucs ; indLemme++ )
    {
            Ducs[ indLemme ].Suivant = NULL;
            MiseAZeroUnLemme( &(Ducs[ indLemme ].Lemme) );
    }
}

/****************************************************************************
                Utilitaires sur les chaines
*****************************************************************************/

/* comparaison entre 2 chaines en tenant compte des lettres accentuees
   retourne _True si InferieurStrict _False sinon                            */

int      InferieurStrict(char *p_str1 , char *p_str2)
{
        int     i = 0;
        char    c1,c2;

        while ( p_str1[i] == p_str2[i])
            if( p_str1[i++] == '\0' )
                return _False;

        c1 = p_str1[ i ];
        c2 = p_str2[ i ];

        if( (unsigned char)Ascii((int)c1) < (unsigned char)Ascii((int)c2))
            return _True;
        else
            return _False;
}

/* verifie l'egalite de 2 chaines de caraceteres entre le caractere no
   borneinf et le caractere bornesup */

int      EgaliteChaine( char *p_ch1 , char *p_ch2 )
{
        int i = 0 ; /* compteur */

        while (p_ch1[i] == p_ch2[i])
        {
            if (p_ch1[i++] == '\0')
            {
                return _True;
            }
        }

        return _False;
}

/****************************************************************************
                      acces aux entrees par hashcode
                 Calcul du HashCode d'un identificateur
*****************************************************************************/
int      Hash( ChIdent  p_identificateur , int p_taille )
{
        int      i = 0;
        int      resul = 0;

        while( p_identificateur[ i ] != '\0' )
        {
                resul = (resul + (unsigned int)p_identificateur[ i ]*(i + 1));
                i++;
        }
        if( resul < 0 )
        {
                resul = -resul;
        }
        return( resul % p_taille );
}

/****************************************************************************
              PATH ASSOCIATED WITH AN ENVIRONMENT VARIABLE
                         RETURNS THE FIRST PATH ONLY
*****************************************************************************/
char    *PathOfEnvirVariable( ChIdent p_envirVariable )
{
  char *substring;

  if( (substring = getenv( p_envirVariable ) ) ) {
    return substring;
  }
  if( strcmp( p_envirVariable , "FASTRBIN" ) == 0 ) {
    return FASTRBIN;
  }
  if( strcmp( p_envirVariable , "FASTR" ) == 0 ) {
    return FASTR;
  }
  if( strcmp( p_envirVariable , "FASTREMPTY" ) == 0 ) {
    return FASTREMPTY;
  }
  if( strcmp( p_envirVariable , "CELEXDIR" ) == 0 ) {
    return CELEXDIR;
  }
  if( strcmp( p_envirVariable , "WORDNETDICT" ) == 0 ) {
    return WORDNETDICT;
  }
  if( strcmp( p_envirVariable , "FASTRTMP" ) == 0 ) {
    if( (substring = getenv( "TMPDIR" ) ) ) {
      return substring;
    }
    else {
      return TMPDIR;
    }
  }
  return NULL;
}

/****************************************************************************
            EXPANSION OF AN ENVIRONMENT VARIABLE IN A STRING
*****************************************************************************/
void    ExpandEnvironementVariable( char p_path[ _NbMaxLetNomFic ] )
{
  ChIdent envirVariable;
  char    pathCopy[ _NbMaxLetNomFic ];

  int     i = 0;
  int     j = 0;

  strcpy( envirVariable , "" );
  strcpy( pathCopy , p_path );
  if( pathCopy[ i++ ] == '$' ) {
    /* copy of the name of the environment variable */
    if( pathCopy[ i ] == '{' ) {
      i++;
      while( pathCopy[ i ] != '}' && i < _MaxLetIdent ) {
	envirVariable[ j++ ] = pathCopy[ i++ ];
      }
      envirVariable[ j++ ] = '\0';
      i++;
    }
    else {
      while( pathCopy[ i ] && pathCopy[ i ] != '/' && i < _MaxLetIdent ) {
	envirVariable[ j++ ] = pathCopy[ i++ ];
      }
      envirVariable[ j++ ] = '\0';
    }

    /* extended value of the environment variable */
    if( PathOfEnvirVariable( envirVariable ) ) {
      strcpy( p_path , PathOfEnvirVariable( envirVariable ) );
    }
    else {
      strcpy( p_path , "" );
    }

    /* addition of the remainder of the path */
    strcat( p_path , pathCopy + i );
  }
}

/*************************************************************************
    remise a zero des indices des buffers d'acces aux fichiers
           pour provoquer un rechargement de ces buffers
**************************************************************************/
void     RAZIndicesBuffersDic( void )
{
    IndBuffLemmeMax = 0L;
    IndBuffRegleMax = 0L;
    IndBuffLemmeMin = 0L;
    IndBuffRegleMin = 0L;
}

/*************************************************************************
                      allocation des buffers de dictionnaire
**************************************************************************/
void     AlloueBuffersLongsEtChargeDico( void )
{
    unsigned long   tailleDico;
    unsigned long   nbLus;

    /* LEMMES */
    /* calcul de la taille du dictionnaire */
    fseek( FicBDicLemmes , 0L , 2 );
    fgetpos( FicBDicLemmes , &tailleDico );
    fseek( FicBDicLemmes , 0L , 0 );
    /* cas ou le petit buffer a une taille superieure a celle du
       dictionnaire */
    if( (unsigned long)TailleBuffLemmesCourt >= tailleDico + 10L )
    {
         BufferLemmesCourant = BufferLemmesCourt;
         TailleBuffLemmesCourant = TailleBuffLemmesCourt;
         nbLus = LireEcrire( 0L , tailleDico , BufferLemmesCourant , 
                             _Lire, FicBDicLemmes );
         if( nbLus != tailleDico )
         {
               sprintf( ChAux , 
                        "AlloueBuffersLongsEtChargeDico(albase) [%ld/->%ld]",
                        tailleDico , nbLus );
               TxtErreur( 58 , ChAux );
         }
         IndBuffLemmeMin = 0L;
         IndBuffLemmeMax = nbLus;
    }
    /* cas ou le petit buffer a une taille superieure a celle du
       dictionnaire */
    else
    /* si le petit buffer a une taille inferieure a celle du dictionnaire */
    /* on utilise le grand buffer */
    {
        /* le buffer long n'a pas encore ete alloue ou il a deja ete alloue */
        /* avec une taille inferieure a celle souhaitee */
        if( (unsigned long)TailleBuffLemmesLong < tailleDico + 10L )
        {
            /* si le buffer a deja ete alloue, on le desalloue */
            if( BufferLemmesLong )
            {
                  _Free( BufferLemmesLong );
                  TailleBuffLemmesLong = 0L;
            }

            /* allocation du buffer long */
            BufferLemmesLong = (char *)_Alloc( tailleDico + 10L );
            if( BufferLemmesLong )
            {
                TailleBuffLemmesLong = tailleDico + 10L;
            }
        }
        /* le buffer long n'a pas encore ete alloue ou il a deja ete alloue */
        /* avec une taille inferieure a celle souhaitee */

        /* echec d'allocation du buffer long, on se reporte sur le
           buffer court */
        if( !BufferLemmesLong )
        {
            sprintf( ChAux , "AlloueBuffersLongs(albase) [%s]" , NomFicDico );
            TxtErreur( 132 , ChAux );
            BufferLemmesCourant = BufferLemmesCourt;
            TailleBuffLemmesCourant = TailleBuffLemmesCourt;
            IndBuffLemmeMin = 0L;
            IndBuffLemmeMax = 0L;
        }
        else
        /* allocation du buffer long reussie ou buffer long precedent
           recupere */
        {
            BufferLemmesCourant = BufferLemmesLong;
            TailleBuffLemmesCourant = TailleBuffLemmesLong;
            nbLus = LireEcrire( 0L , tailleDico , BufferLemmesCourant , 
                                _Lire, FicBDicLemmes );
            if( nbLus != tailleDico )
            {
                  sprintf( ChAux ,
                          "AlloueBuffersLongsEtChargeDico(albase) [%ld/->%ld]",
                           tailleDico , nbLus );
                  TxtErreur( 58 , ChAux );
            }
            IndBuffLemmeMin = 0L;
            IndBuffLemmeMax = nbLus;
        }
    }

    /* REGLES */
    /* calcul de la taille du dictionnaire */
    fseek( FicBDicRegles , 0L , 2 );
    fgetpos( FicBDicRegles , &tailleDico );
    fseek( FicBDicRegles , 0L , 0 );
    /* cas ou le petit buffer a une taille superieure a celle du
       dictionnaire */
    if( (unsigned long)TailleBuffReglesCourt >= tailleDico + 10L )
    {
         BufferReglesCourant = BufferReglesCourt;
         TailleBuffReglesCourant = TailleBuffReglesCourt;
         nbLus = LireEcrire( 0L , tailleDico , BufferReglesCourant , 
                             _Lire, FicBDicRegles );
         if( nbLus != tailleDico )
         {
               sprintf( ChAux ,       
                        "AlloueBuffersLongsEtChargeDico(albase) [%ld/->%ld]",
                        tailleDico , nbLus );
               TxtErreur( 58 , ChAux );
         }
         IndBuffRegleMin = 0L;
         IndBuffRegleMax = nbLus;
    }
    /* cas ou le petit buffer a une taille superieure a celle du
       dictionnaire */
    else
    /* si le petit buffer a une taille inferieure a celle du dictionnaire */
    /* on utilise le grand buffer */
    {
        /* le buffer long n'a pas encore ete alloue ou il a deja ete alloue */
        /* avec une taille inferieure a celle souhaitee */
        if( (unsigned long)TailleBuffReglesLong < tailleDico + 10L )
        {
            /* si le buffer a deja ete alloue, on le desalloue */
            if( BufferReglesLong )
            {
                  _Free( BufferReglesLong );
                  TailleBuffReglesLong = 0L;
            }

            /* allocation du buffer long */
            BufferReglesLong = (char *)_Alloc( tailleDico + 10L );
            if( BufferReglesLong )
            {
                TailleBuffReglesLong = tailleDico + 10L;
            }
        }
        /* le buffer long n'a pas encore ete alloue ou il a deja ete alloue */
        /* avec une taille inferieure a celle souhaitee */

        /* echec d'allocation du buffer long, on se reporte sur le
           buffer court */
        if( !BufferReglesLong )
        {
            sprintf( ChAux , "AlloueBuffersLongs(albase) [%s]" , NomFicDico );
            TxtErreur( 132 , ChAux );
            BufferReglesCourant = BufferReglesCourt;
            TailleBuffReglesCourant = TailleBuffReglesCourt;
            IndBuffRegleMin = 0L;
            IndBuffRegleMax = 0L;
        }
        else
        /* allocation du buffer long reussie ou buffer long precedent
           recupere */
        {
            BufferReglesCourant = BufferReglesLong;
            TailleBuffReglesCourant = TailleBuffReglesLong;
            nbLus = LireEcrire( 0L , tailleDico , BufferReglesCourant , 
                                _Lire, FicBDicRegles );
            if( nbLus != tailleDico )
            {
                  sprintf( ChAux , 
                      "AlloueBuffersLongsEtChargeDico(albase) [%ld/->%ld]",
                                   tailleDico , nbLus );
                  TxtErreur( 58 , ChAux );
            }
            IndBuffRegleMin = 0L;
            IndBuffRegleMax = nbLus;
        }
    }

    /* LIENS */
    /* calcul de la taille du dictionnaire */
    fseek( FicBDicLiens , 0L , 2 );
    fgetpos( FicBDicLiens , &tailleDico );
    fseek( FicBDicLiens , 0L , 0 );

    /* allocation du buffer de liens */
    BufferLiensMorphologiquesEtSemantiques 
      = (char *)_Alloc( tailleDico + 10L );
    if( BufferLiensMorphologiquesEtSemantiques )
    {
         nbLus = LireEcrire( 0L , tailleDico , 
			     BufferLiensMorphologiquesEtSemantiques , 
                             _Lire, FicBDicLiens );
         if( nbLus != tailleDico )
         {
               sprintf( ChAux ,       
                        "AlloueBuffersLongsEtChargeDico(albase) [%ld/->%ld]",
                        tailleDico , nbLus );
               TxtErreur( 58 , ChAux );
         }
    }
}

/*************************************************************************
                      allocation des buffers de dictionnaire
**************************************************************************/
void     DesalloueBuffersLongsEtDechargeDico( void )
{
    /* LEMMES */
    BufferLemmesCourant = BufferLemmesCourt;
    TailleBuffLemmesCourant = TailleBuffLemmesCourt;

    /* REGLES */
    BufferReglesCourant = BufferReglesCourt;
    TailleBuffReglesCourant = TailleBuffReglesCourt;

    RAZIndicesBuffersDic();
}

/*****************************************************************************
            Ouverture des dictionnaires de lemmes, de regles et de liens
*****************************************************************************/
char     OuvreDictionnaire( int p_estLecture )
{
    char            nomFicIdent[ 256 ];
    char            nomFicDicLemmes[ 256 ];
    char            nomFicDicRegles[ 256 ];
    char            nomFicDicLiens[ 256 ];
    char            ok = _True;

    if( FicBDicLemmes || FicBDicRegles || FicBDicLiens 
        || FicRefIdent || FicRefMots )
    {
        sprintf( ChAux , "OuvreDictionnaire(albase) [%s]" , NomFicDico );
        TxtErreur( 138 , ChAux );
        FermeDictionnaire();
    }

    strcpy( nomFicIdent , NomFicDico );
    strcat( nomFicIdent , ".IDE" );
    strcpy( nomFicDicLemmes , NomFicDico );
    strcat( nomFicDicLemmes , ".LEM" );
    strcpy( nomFicDicRegles , NomFicDico );
    strcat( nomFicDicRegles , ".RUL" );
    strcpy( nomFicDicLiens , NomFicDico );
    strcat( nomFicDicLiens , ".LIN" );
    if( p_estLecture )
    {
        FicBDicLemmes = fopen( nomFicDicLemmes , _FopenRPB );
        FicBDicRegles = fopen( nomFicDicRegles , _FopenRPB );
        FicBDicLiens = fopen( nomFicDicLiens , _FopenRPB );
        FicRefIdent = fopen( nomFicIdent , _FopenRPT );
    }
    else
    {
        FicBDicLemmes = fopen( nomFicDicLemmes , _FopenWPB );
        FicBDicRegles = fopen( nomFicDicRegles , _FopenWPB );
        FicBDicLiens = fopen( nomFicDicLiens , _FopenWPB );
        FicRefIdent = fopen( nomFicIdent , _FopenWPT );
    }

    if( !FicBDicLemmes || !FicBDicRegles || !FicBDicLiens || !FicRefIdent )
    {
        if( !TraitementBatch )
        {
            sprintf( ChAux , "OuvreDictionnaire(albase) [%s]" , NomFicDico );
            TxtErreur( 147 , ChAux );
        }
        return _False;
    }

    strcpy( nomFicIdent , NomFicDico );
    strcat( nomFicIdent , ".REF" );
    FicRefMots = fopen( nomFicIdent , _FopenRPT );
    if( !FicRefMots )
    {
        if( !OuvreFichier( nomFicIdent , &FicRefMots , _FopenWPT ) )
        {
             return _False;
        }
    }
    return ok;
}

/*****************************************************************************
            Fermeture des dictionnaires de lemmes et de regles
*****************************************************************************/
void     FermeDictionnaire( void )
{
     if( FicBDicLemmes )
     {
        fclose( FicBDicLemmes );
     }
     FicBDicLemmes = NULL;
     if( FicBDicRegles )
     {
        fclose( FicBDicRegles );
     }
     FicBDicRegles = NULL;
     if( FicBDicLiens )
     {
        fclose( FicBDicLiens );
     }
     FicBDicLiens = NULL;
     if( FicRefIdent )
     {
        fclose( FicRefIdent );
     }
     FicRefIdent = NULL;
     if( FicRefMots )
     {
        fclose( FicRefMots );
     }
     FicRefMots = NULL;
}

/*****************************************************************************
            Changement de nom de dico
*****************************************************************************/
char     ChangeDictionnaire( char *p_nomDico )
{
     char                chMot[ 256 ];

    if( strcmp( p_nomDico , NomFicDico ) == 0 )
    {
         return _True;
    }
    strcpy( chMot , NomFicDico );
    strcpy( NomFicDico , p_nomDico );
    FermeDictionnaire();
    if( OuvreDictionnaire( _True ) )
    {
         LireBArbre();
         return _True;
    }
    else
    {
        exit(0);
    }
}

/*****************************************************************************
            Ouverture du fichier des Lemme
*****************************************************************************/
char     SauveArchivesDictionnaire( void )
{
        char            ligneCommande[ 256 ];

        FermeDictionnaire();

        sprintf( ligneCommande , "cp %s.IDE %s.IDE.arc\n" , 
                 NomFicDico , NomFicDico );
        system( ligneCommande );
        sprintf( ligneCommande , "cp %s.LEM %s.LEM.arc\n" , 
                 NomFicDico , NomFicDico );
        system( ligneCommande );
        sprintf( ligneCommande , "cp %s.RUL %s.RUL.arc\n" , 
                 NomFicDico , NomFicDico );
        system( ligneCommande );
        sprintf( ligneCommande , "cp %s.LIN %s.LIN.arc\n" , 
                 NomFicDico , NomFicDico );
        system( ligneCommande );

        return OuvreDictionnaire( _True );
}

/*****************************************************************************
            Bootstrap du fichier des Lemme
                avant la 1ere utilisation sur un nouveau lexique
*****************************************************************************/
long     BootStrapFichierLemmes( FILE *p_ptFic )
{
    unsigned long             posCour = 0L;
    unsigned long             posInsertionSuivante = 0L;
    long                      refAbs = (long)_PremRefLemme;
    long                      i;
    char                      premSeparation[ _TailleSeparation + 1 ];
    ChIdent                   chaineAux;
    ChIdent                   chaine;
    struct LemmeMem           lemme;
    long                      longTChar = 0L;

    if( LireEcrire( posCour , (long) _TailleAmorce , (TabChar) &refAbs ,
                    _Ecrire , p_ptFic ) < 0L )
    {
        FermeDictionnaire();
        return 0L;
    }
    posCour += (unsigned long)_TailleAmorce;

    for( i = 0L ; i < (long)_TailleSeparation ; i++ )
    {
         premSeparation[ i ] = '\0';
    }
    if( LireEcrire( posCour , (long) _TailleSeparation , 
                    (TabChar)premSeparation,
                    _Ecrire , p_ptFic ) < 0L )
    {
        FermeDictionnaire();
        return 0L;
    }
    posCour += (unsigned long)_TailleSeparation;

    MiseAZeroUnLemme( &lemme );
    chaineAux[0] = '\0';
    strcpy( chaine , PremLemme );
    longTChar = DestructurerLemme( chaine , &lemme  , 
                BufferLemmesCourt , chaineAux );
    if( LireEcrire( posCour , longTChar , BufferLemmesCourt ,
                    _Ecrire , p_ptFic ) < 0L )
    {
        FermeDictionnaire();
        return 0L;
    }

    posCour += (unsigned long)longTChar;
    posInsertionSuivante = posCour;
    strcpy( chaine , DernLemme );
    longTChar = DestructurerLemme( chaine , &lemme , 
                                   BufferLemmesCourt , chaineAux );
    if( LireEcrire( posCour , longTChar , BufferLemmesCourt ,
                    _Ecrire , p_ptFic ) < 0L )
    {
        FermeDictionnaire();
        return 0L;
    }
    return posInsertionSuivante;
}

char     BootstrapDictionnaire( int p_nouveauDico , 
                                int p_chargementApplication )
{
    if( !p_nouveauDico )
    {
        if( !TxtReponseBinaire( 1 ) )
        {
            return _True;
        }
    }

    FermeDictionnaire();
    if( !OuvreDictionnaire( _False ) )
    {
         return _False;
    }

    BootStrapFichierIdent( FicRefIdent );
    if( !BootStrapFichierLemmes( FicBDicLemmes ) ) {
         return _False;
    }

    FermeDictionnaire();
    if( !OuvreDictionnaire( _True ) )
    {
        return _False;
    }

    if( !IniBArbre() )
    {
        return _False;
    }
    
    if( !p_chargementApplication )
    {
        RAZDonneesEnTete();
        if( !LitEnTeteGrammaireEtErreur() )
        {
            return _False;
        }
    }
    
    return _True;
}

/*************************************************************************
    acces au fichiers des regles et des lemmes dans les cas ou l'indice
            n'est pas dans le domaine couvert par le buffer
**************************************************************************
 lecture d'un Lemme ou d'une regle qui n'est pas dans le buffer
  pt  indice absolu du Lemme ou de la regle lue                  */

long     IndRelBDic( unsigned long p_ptFicBDico , int p_typeDico )
{
    long                   ind;
    int                    i;      /* compteur de caracteres nuls */

    long                   tailleRestanteDuFichier;
    unsigned long          tailleFic;
    long                   tailleBuffer;
    long                   nbLus;
    TabChar                buffer;
    FILE                  *ptFic;

    if( p_typeDico == _Lemmes )
    {
        ptFic = FicBDicLemmes;
        tailleBuffer = TailleBuffLemmesCourant;
        buffer = BufferLemmesCourant;
    }
    else
    {
        ptFic = FicBDicRegles;
        tailleBuffer = TailleBuffReglesCourant;
        buffer = BufferReglesCourant;
    }

    if( !ptFic )
    {
        TxtErreur( 23 , "IndRelBDic(albase)" );
        return _Nil;
    }

    /* on a essaye _IRelLemme qui ne peut repondre car on est en dehors de l'
    intervalle des indices du buffer, donc on doit faire une lecture fichier */
    fseek( ptFic , 0L , 2 );
    fgetpos( ptFic , &tailleFic );
    tailleRestanteDuFichier = (long)(tailleFic - p_ptFicBDico);

    /* dictionnaire sur disque, acces bufferise */
    if( (p_typeDico == _Lemmes && buffer == BufferLemmesLong)
        || (p_typeDico == _Regles && buffer == BufferReglesLong) )
    /* dictionnaire en memoire, lecture unique */
    {
           if( p_typeDico == _Lemmes )
	   {
               printf( "\nLemmas pos [%ld/%ld]\n" , p_ptFicBDico ,
		      tailleFic );
	   }
           if( p_typeDico == _Regles )
	   {
               printf( "\nRules pos [%ld/%ld]\n" , p_ptFicBDico ,
		      tailleFic );
	   }
           TxtErreur( 139 , "IndRelBDic(albase)" );
           fclose( FicLog );
           exit( 0 );
    }
    /* dictionnaire en memoire, lecture unique */

    nbLus = _Min( tailleRestanteDuFichier , (long)tailleBuffer );
    if( nbLus <= 0L )
    {
          sprintf( ChAux , "IndRelBDic(albase) [%ld/%ld,->%ld]",
                  tailleRestanteDuFichier , tailleFic , p_ptFicBDico );
          TxtErreur( 51 , ChAux );
          return _Nil;
    }

    nbLus = LireEcrire( p_ptFicBDico , nbLus , buffer , _Lire , ptFic );
    if( nbLus <= 0L )
    {
          sprintf( ChAux , "IndRelBDic(albase) [%ld/%ld,->%ld]",
                  tailleRestanteDuFichier , tailleFic , p_ptFicBDico );
          TxtErreur( 24 , ChAux );
          return _Nil;
    }

    if( p_typeDico == _Lemmes )
    {
        IndBuffLemmeMin = p_ptFicBDico;
    }
    else
    {
        IndBuffRegleMin = p_ptFicBDico;
    }

    /* on met comme indice maximal l'indice du 6eme 0 du 000000 du
       dernier Lemme complet inclus dans le buffer */
    ind = nbLus - 1L;
    i = 0L;
    while( _False != _True && ind != 0L )
    {
        if ( buffer[ ind ] == '\0')
        {
            i++;
        }
        else
        {
            i = 0;
        }

        ind--;

        if( i == _TailleSeparation && ind >= 0L )
        {
            if ( buffer[ ind ] == '\0')
            {
                sprintf( ChAux , "IndRelBDic(albase) [%ld]" , ind );
                TxtErreur( 123 , ChAux );
                return _Nil;
            }
            break;
        }
        if( ind == 0L )
        {
            TxtErreur( 25 , "IndRelBDic(albase)" );
            return _Nil;
        }
    }
    if( ind == 0L )
    {
        sprintf( ChAux , "IndRelBDic(albase) [%ld]" , p_ptFicBDico );
        TxtErreur( 124 , ChAux );
        return _Nil;
    }
    else
    {
        if( p_typeDico == _Lemmes )
        {
            IndBuffLemmeMax = p_ptFicBDico + (unsigned long)ind 
                              + (unsigned long)_TailleSeparation + 1L;
        }
        else
        {
            IndBuffRegleMax = p_ptFicBDico + (unsigned long)ind 
                              + (unsigned long)_TailleSeparation + 1L;
        }
    }
    return 0L;
}

/****************************************************************************
     Recherche d'un mot par BArbre retourne l'ind absolu d'un Lemme
***************************************************************************/

unsigned long     RechercheBArbre( char *p_chaine , int p_avecTrace )
{
    int                        niveauCou; /* niveau courant de recherche     */
    int                        j;
    long                       indB_Arb      = 0L;
    long                       indLocB_Arb;
    long                       decalage;
    int                        indiceCar     = 0;
    char                      *ptChB_Arb;
    char                      *ptChDonnee,
                               ch1,ch2;

    indiceCar = 0;

    for (niveauCou = 1 ; niveauCou < ProfondeurBArbre ; niveauCou++)
    {
       if( p_avecTrace )
       {
          fprintf( FicLog , "Recherche : niveau %d ind abs %ld\n" , 
                                 niveauCou , indB_Arb );
       }

       /* on s'arrete sur la premiere porte superieure a la
           fin de la table locale de NbPortesBArbre portes        */
       indLocB_Arb = 0L;
       while( indLocB_Arb < NbPortesBArbre )
       {
           ptChB_Arb = B_ArbInf[indB_Arb + indLocB_Arb].ChaineBAr;
           ptChDonnee = &p_chaine[indiceCar];
           if( p_avecTrace )
           {
               fprintf( FicLog , 
                    "Indice abs %ld  chaine donnee %.4s chaine B-arbre %.4s\n" ,
                     indB_Arb , ptChDonnee , ptChB_Arb );
           }

           j = 0;
           while ( j < _NbMaxLetBArb
                   && ptChB_Arb[j] == ptChDonnee[j]
                   && ptChDonnee[j] != '\0')
           {
                    j++;
           }

           ch1 = ptChB_Arb[j]; ch2 = ptChDonnee[j];
           if (j < _NbMaxLetBArb 
               && (unsigned char)Ascii((int)ch1) > (unsigned char)Ascii((int)ch2)
               && !( ch1 == ' ' && ch2 == '\0' ) )
           {
                break;
           }
           else
           {
               indLocB_Arb++;
           }
       }

       /* on s'est arrete en fin de table ou sur la premiere limite
          superieure au mot */
       /* le mot est donc dans la table de niveau superieur qui
          commence a la limite precedente */
       /* l'indice lu a un niveau vaut pour le niveau superieur */
       if( indLocB_Arb > 0 )
           indiceCar = B_ArbInf[indB_Arb + indLocB_Arb - 1 ].IndCar;

       decalage = indB_Arb - TPremIndB_Arb[ niveauCou ];
       indB_Arb = TPremIndB_Arb[ niveauCou + 1 ] +
                   ( decalage + indLocB_Arb + (int)( decalage / NbPortesBArbre ))
                   * NbPortesBArbre;

       if( p_avecTrace )
       {
          fprintf( FicLog , "Arret : niveau %d ind abs %ld\n" , 
                                  niveauCou , indB_Arb );
       }
    }

    if( p_avecTrace )
    {
        fprintf( FicLog , "Recherche arbre sup : niveau %d ind abs %ld\n" , 
                                niveauCou , indB_Arb );
    }
    /* tour de niveau maximal : niveau */
    while (indB_Arb < TailleBArbSup)
    {
        ptChB_Arb = B_ArbSup[ indB_Arb ].ChaineBAr;
        ptChDonnee = &p_chaine[ indiceCar ];
        if( p_avecTrace )
        {
            fprintf( FicLog , 
                    "Indice abs %ld  chaine donnee %.4s chaine B-arbre %.4s\n" ,
                     indB_Arb , ptChDonnee , ptChB_Arb );
        }

        j = 0;
        while ( j < _NbMaxLetBArb && ptChB_Arb[ j ] == ptChDonnee[ j ]
                               && ptChDonnee[ j ] != '\0')
        {
                j++;
        }

        ch1 = ptChB_Arb[j]; ch2 = ptChDonnee[j];
        if( j < _NbMaxLetBArb 
            && (unsigned char)Ascii((int)ch1) > (unsigned char)Ascii((int)ch2)
            && !( ch1 == ' ' && ch2 == '\0' ) )
        {
                 break;
        }
        else
        {
                indB_Arb++;
        }
    }
    
    if( indB_Arb > TPremIndB_Arb[niveauCou] )
    {
           indB_Arb--;
    }

    return( B_ArbSup[indB_Arb].PosFicLemme 
            - (unsigned long)_TailleSeparation );
}

/****************************************************************************
           recherche de l'indice absolu d'un Lemme par sa chaine
****************************************************************************
   renvoit l'indice absolu de debut de la chaine dans le fichier pour une
   chaine donnee. Si la chaine n'est pas trouvee, renvoit l'indice de debut
   de la chaine superieure                                              */

unsigned long     IndiceInsertionDicLemmes( char *p_chaine , char *p_trouvee )
{
    unsigned long   indAbs;

    int             i;
    long            ind;
    TabChar         chaineLemme;

    indAbs = RechercheBArbre( p_chaine , _False );

    /* saut des Lemme dont la chaine est inferieure a la chaine donnee*/
    /* a chaque nouveau Lemme on provoque un rechargement du buffer  */
    chaineLemme = BufferLemmesCourant + _IRelLemme(indAbs);
    do
    {
        /* saut juqu'a une separation                                v */
        i = 0;
        while( _False != _True )
        {
            if ( BufferLemmesCourant[ _IRelLemme( indAbs ) ] == '\0')
            {
                i++;
            }
            else
            {
                i = 0;
            }
            indAbs++;

            if( i == _TailleSeparation)
            {
                if ( BufferLemmesCourant[ _IRelLemme( indAbs ) ] == '\0')
                {
                    sprintf( ChAux , 
                             "IndiceInsertionDicLemmes(albase) [%ld]" , 
                             _IRelLemme( indAbs ) );
                    TxtErreur( 125 , ChAux );
                    for( ind = _IRelLemme( indAbs ) - 10 ; 
                         ind < _IRelLemme( indAbs ) + 10 ; ind++ )
                    {
                        sprintf( ChAux , "BufferLemmesCourant[%ld] = %c %d\n", 
                                         ind , BufferLemmesCourant[ ind ], 
                                         BufferLemmesCourant[ ind ] );
                        printf( ChAux );
                    }
                }
                break;
            }
        }
        chaineLemme = BufferLemmesCourant + _IRelLemme(indAbs);
    }
    while( InferieurStrict( chaineLemme , p_chaine ) == _True );

    if( EgaliteChaine( BufferLemmesCourant + _IRelLemme(indAbs) , p_chaine ) == _True )
    {
        *p_trouvee = _True;
    }
    else
    {
        *p_trouvee = _False;
    }

    return indAbs;
}

/****************************************************************************
       nombre de regles et de mots simples dans le dictionnaire courant
*****************************************************************************/
long     NbIdentReglesDictionnaire( void )
{
   long                            nbReglesTot;

    /* calcul du nombre total de regles */

    fseek( FicRefIdent , 0L , 0 );
    LitEnTete( FicRefIdent , &nbReglesTot );
    
    return nbReglesTot;
}

long     NbLemmesDictionnaire( void )
{
    long                        refMotsSimples;  /* reference absolue du Lemme suivant */

    LireEcrire( 0L , (long)_TailleAmorce , (TabChar)(&refMotsSimples) ,_Lire , 
                FicBDicLemmes );
    return (refMotsSimples - _PremRefLemme + 2L);
}

/****************************************************************************
                      initialisation du barbre
*****************************************************************************
   tabind tableau d'indices servant a calculer le decalage pour passer
   d'un niveau au niveau superieur du barbre A APPELER 
   AVANT LES INITIALISATIONS
   DE GRANDS TABLEAUX !!!!!!! (QUI UTILISENT TailleBArbInf 
   ET TailleBArbSup )  */

void     IniTabIndEtFichiers( void )
{
    int                 i;

    /**********   initialisation b-arbres    *********/
    TPremIndB_Arb = (long *)_Alloc( (ProfondeurBArbre + 1) * sizeof( long ) );
    TNbTermesB_Arb = (long *)_Alloc( (ProfondeurBArbre + 1) * sizeof( long ) );
    if( !TPremIndB_Arb || !TNbTermesB_Arb )
    {
        TxtErreur( 19 , "IniTabIndEtFichiers(albase)" );
         exit(0);
    }

    TPremIndB_Arb[ 1 ] = 0;
    TNbTermesB_Arb[ 1 ] = NbPortesBArbre;
    TailleBArbInf = (long)NbPortesBArbre;
    TailleBArbSup = (long)NbPortesBArbre * ((long)NbPortesBArbre + 1L);

    for( i = 2 ; i < ProfondeurBArbre ; i++ )
    {
        TPremIndB_Arb[ i ] =
                TPremIndB_Arb[ i - 1 ] + TNbTermesB_Arb[ i - 1 ] ;
        TNbTermesB_Arb[i] =
                TNbTermesB_Arb[ i - 1 ] * (NbPortesBArbre + 1);

        TailleBArbInf = TailleBArbInf * ((long)NbPortesBArbre + 1L) 
                        + (long)NbPortesBArbre;
        TailleBArbSup *= ((long)NbPortesBArbre + 1L);
    }

    TPremIndB_Arb[ ProfondeurBArbre ] = 0;
    TNbTermesB_Arb[ ProfondeurBArbre ] =
        TNbTermesB_Arb[ ProfondeurBArbre - 1 ] * (NbPortesBArbre + 1);

    if( TPremIndB_Arb[ ProfondeurBArbre - 1 ] 
               + TNbTermesB_Arb[ ProfondeurBArbre - 1 ] 
        > TailleBArbInf || ProfondeurBArbre < 2 )
    {
        TxtErreur( 26 , "IniTabIndEtFichiers(albase)" );
    }
    if( TPremIndB_Arb[ ProfondeurBArbre ] + TNbTermesB_Arb[ ProfondeurBArbre ] 
        > TailleBArbSup)
    {
        TxtErreur( 27 , "IniTabIndEtFichiers(albase)" );
    }

    /**********   initialisation dictionnaires    *********/
    if( *NomFicLog ) {
      OuvreFichier( NomFicLog , &FicLog , _FopenWPT );
    }
    else {
      FicLog = stdout;
    }
    FicBDicLemmes = NULL;
    FicBDicRegles = NULL;
    FicBDicLiens = NULL;
    FicRefIdent = NULL;
    FicRefMots = NULL;
    FicBufferiseCourant = NULL;

    RAZIndicesBuffersDic();
    IndCar = 0L;
    IndCarM = 0L;
    IndCarSortieM = 0L;
    EstEntreeSortieBuffer = _False;

    if( (char)255 == EOF )
    {
       for( i = 0 ; i < _MaxLetIdent ; i++ )
       {
           DernLemme[ i ] = (char)254;
       }
    }
    else
    {
       for( i = 0 ; i < _MaxLetIdent ; i++ )
       {
           DernLemme[ i ] = (char)255;
       }
    }
    DernLemme[ _MaxLetIdent ] = '\0';
    PremLemme[ 0 ] = (char)1;
    PremLemme[ 1 ] = '\0';
}

/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
            fin de albase.c
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
