/*
 * FASt Term Recognizer
 *
 *  FASTR/algraph.c
 *  Version 2.04/04-02-01
 *
 *  Copyright (C) 2004  Christian Jacquemin, LIMSI-CNRS
 *
 *  This file contains code for user interaction
 */

#include "al-ext.h"
#include "al-var.h"
#ifndef MACGRAPH
#include "al-graph.h"
#endif

#ifndef WARNINGS
#include "al-head.h"
#endif
#ifdef WARNINGS
#include "al-headP.h"
#endif

/****************************************************************************
             RETROUVER UNE RESSOURCE DANS LE FICHIER CORRESPONDANT
*****************************************************************************/
void     TxtChaineFicRsrc( int p_indRsrc , char *p_nomFic , 
                           int p_indCh , char *p_ch )
{
     char                  carLu;
     int                   indChaineRes;
     int                   indRes;
     int                   indChar;
     FILE                  *ptFicRes;

     ptFicRes = fopen( p_nomFic , _FopenRT );
     if( !ptFicRes )
     {
         /* ne pas appeler TxtErreur car risque de boucle infernale */
         sprintf( ChAux , 
	   "fastr: Error 0: file [%s] missing\n" , 
                  p_nomFic );
	 printf( ChAux );
         exit( 0 );
     }
     
     /* pour les resources generales (131 a 135) on doit sauter 
        jusqu'a la bonne serie de chaines */
     carLu = getc( ptFicRes );
     if( p_indRsrc >= 1 )
     {
         indRes = 0;
         while( indRes < p_indRsrc && carLu != EOF )
         {
            carLu = getc( ptFicRes );
            if( carLu == '#' )
            {
                indRes++;
            }
         }
         while( carLu != '[' && carLu != EOF )
         {
            carLu = getc( ptFicRes );
         } 
     }

     indChaineRes = 1;
     while( indChaineRes < p_indCh && carLu != EOF )
     {
         while( carLu >= ' ' && carLu != EOF )
         {
            carLu = getc( ptFicRes );
         }
         while( carLu < ' ' && carLu != EOF )
         {
            carLu = getc( ptFicRes );
         }
         indChaineRes++;
     }

     indChar = 0;
     /* saut de l'indice de la ressource entre crochets */
     if( carLu =='[' )
     {
         while( carLu >= ' ' && carLu != EOF && carLu != ']' )
         {
              carLu = getc( ptFicRes );
         }
         if( carLu == ']' )
         {
              carLu = getc( ptFicRes );
         }
     }
     /* copie de la chaine de la ressource */
     while( carLu >= ' ' && carLu != EOF && indChar < 255 )
     {
         p_ch[ indChar ] = carLu;
         carLu = getc( ptFicRes );
         indChar++;
     }
     p_ch[ indChar ] = '\0';

     fclose( ptFicRes );
}

/****************************************************************************
             RETROUVER UNE RESSOURCE DANS LE FICHIER CORRESPONDANT
*****************************************************************************/
void     TxtChaineRsrc( int p_indRsrc , int p_indCh , char *p_ch )
{
    if( _MachineGraphique && ( p_indRsrc <= 130  || p_indRsrc >= 200  ) )
    {
        _ChaineRsrc( p_indRsrc , p_indCh , p_ch );
    }
    else
    {
         TxtChaineFicRsrc( p_indRsrc - 130 , NomFicMessages , p_indCh , p_ch );
    }
}

/****************************************************************************
             RETROUVER UNE CHAINE RESSOURCE D'ERREUR
*****************************************************************************/
void     TxtChaineErreur( int p_indCh , char *p_ch )
{
    TxtChaineFicRsrc( 136 - 130 , NomFicMessages , p_indCh , p_ch );
}

/****************************************************************************
                      recuperation des Erreurs
****************************************************************************/

void     TxtErreur( int p_noErreur , char *p_chaineMessage )
{
   char                   chRsrc[ 256 ];

   if( _MachineGraphique )
   {
       TxtChaineErreur( p_noErreur , chRsrc );
        _DialErreur( p_noErreur , p_chaineMessage , chRsrc );
   }
   else
   {
       TxtChaineErreur( p_noErreur , chRsrc );
       printf( "fastr: Error %d: %s [%s]\n" , 
               p_noErreur , chRsrc , p_chaineMessage );

       if( !TraitementBatch )
       {
           TxtAttente();
           exit(0);
       }
       else
       {
           exit(0);
       }
   }
}

/****************************************************************************
                     EFFACEMENT et ATTENTE UTILISATEUR
****************************************************************************/
void     TxtAttente( void )
{
   char    c;

   if( _MachineGraphique )
   {
         printf("(mouse dwn)");_AttendClick();
   }
   else
   {
        /* _AllerXY(75,23); */
        printf("(hit return or q(uit))\n");
        while ((c = getchar()) != '\n' && c != 'q' && c != 3);
        printf("\n");
	if( c == 'q' ) {
	  exit( 0 );
	}
   }
}

/****************************************************************************
                        MENU DE DEMANDE OUI/NON A L'UTILISATEUR
****************************************************************************/

char     TxtReponseBinaire( int p_indTitre )
{
    char       c;
    char       chAux[ 256 ];

    if( _MachineGraphique )
    {
        return ( _DialogueReponseTernaire( p_indTitre , _True ) == _Oui );
    }
    if( !TraitementBatch )
    {
        if( p_indTitre > 0 )
        {
            TxtChaineRsrc( 132 , p_indTitre , chAux );
        }
        else
        {
             *ChAux = '\0';
        }
        _Cs();
        _AllerXY( 1 , 23 );
        printf( chAux );
        _AllerXY( 1 , 24 );
        printf("Votre reponse (o/n) : ");
        do
        {
            _AllerXY(40 , 24);printf("-> .");_AllerXY(43,24);
        }
        while((c = getchar()) != 'n' && c != 'N' && c != 'O' && c != 'o' );

        return( (char) ( c == 'o' || c == 'O' ));
    }
    else
    {
        return _False;
    }
}

/****************************************************************************
                      Menu de lecture d'une chaine
****************************************************************************/

char     TxtLireChaine( char *p_titre , int p_indTitre, char *p_chaine, 
                         int p_longMax , int p_mode )
{
    int                 i;
    char                carLu;
    char                chTitre[ 256 ];
    char                chDem[ 256 ];

    if( _MachineGraphique )
    {
        carLu = (_DialogueLireChaine( p_indTitre , 11 , 
                                      p_chaine , p_longMax , 131 ) == _Oui);
        return carLu;
    }

    if( !TraitementBatch )
    {
        if( !p_titre )
        {
            TxtChaineRsrc( 132 , p_indTitre , chTitre );
        }
        else
        {
            strcpy( chTitre , p_titre );
        }
        TxtChaineRsrc( 132 , 11 , chDem );
        /* ecriture du titre                                    */
        _Cs();
        _AllerXY( (_NbLColEcran - strlen( chTitre )) / 2 , 2);
        printf( chTitre );
        printf("\n");

        _AllerXY(18,10);
        printf( chDem );

        _AllerXY( 21 , 10 );
        for ( i = 1 ; i <= p_longMax ; i++ )
                printf( "." );

        _AllerXY( 21 , 10 );

        i = 0;
        while( i < p_longMax && (carLu = getchar()) != (char)13
                && carLu != '\n'
                &&  carLu != _EnterNum )
        {
                if( carLu == 8 )
                {
                        if ( i > 0 )
                        {
                                i--;
                        }
                        /*_AllerXY( 21 + i , 10 );
                        printf( "." );
                        _AllerXY( 21 + i , 10 );*/
                }
                else if ( p_mode == _Numerique && !(_Num(carLu)) )
                {
                        /*sprintf( ChAux , "%c" , 7 );
                        printf( ChAux );
                        _AllerXY( 21 + i , 10 );
                        printf( "." );
                        _AllerXY( 21 + i , 10 );*/

                }
                else
                {
#ifndef MACNONGRAPH
	                /*sprintf( ChAux , "%c" , carLu );
                        printf( ChAux );*/
#endif
                        p_chaine[ i++ ] = carLu;
                }
        }

        p_chaine[ i ] = '\0';
        return _True;
    }
    else
    {
        *p_chaine = '\0';
        return _False;
    }
}

/****************************************************************************
                        MENU DE DEMANDE D'UN ENTIER
****************************************************************************/

long     TxtLireEntier( char *p_titre  , long p_borneInf , long p_borneSup )
{
        long            resul = 0L;
        int             i,longMax;
        char            chaine[ 256 ];

        sprintf( ChAux , "%s ( %ld - %ld ) :",
                 p_titre, p_borneInf , p_borneSup );

        /* cas de nombres positifs  */
        if( p_borneSup < 10L )
                longMax = 1;
        else if( p_borneSup < 100L )
                longMax = 2;
        else if( p_borneSup < 1000L )
                longMax = 3;
        else
                longMax = 8;

        do
        {
            resul = 0L;
            if( !TxtLireChaine( ChAux , 0 , chaine, longMax , _Numerique ) )
            {
                return 0L;
            }
            for( i = 0 ; i < (int)strlen( chaine ) ; i++ )
                resul = resul * 10L + (long)( chaine[ i ] - '0' );

            if( resul >= p_borneInf && resul <= p_borneSup )
            {
                break;
            }
        }
        while( _True );

        return resul;
}

/****************************************************************************
                        MENU DE DEMANDE D'UN CHOIX A L'UTILISATEUR
****************************************************************************
   en entree : 3 parametres
        * le titre : une chaine
        * un tableau de chaines de caracteres : les propositions
        * un tableau de caracteres de meme taille que le precedent : les
          reponses attendues.
   en retour : renvoit le numero de la reponse choisie
   la dermiere reponse proposee est '\0'                                */

int      TxtMenu( char *p_titre, char p_rubriques[][_NbLColEcran], char *p_reponses )
{
#define _premLigne 4
#define _nbRepPremCol (2 * (_NbLigneEcran - 6))

    char    reponse;
    int     i,
            nbrep;
    char    chaine[ 256 ];
    char    carPrec;

    if( TraitementBatch )
    {
        return _Nil;
    }

    if (p_reponses[ 0 ] == '\0')
    {
         TxtErreur( 79 , "TxtMenu(algraph)" );
    }
    _Cs();
    /* ecriture du titre                                */
    _AllerXY( (_NbLColEcran - strlen(p_titre)) / 2 , 2 );
    printf( p_titre );
    printf( "\n\n" );

    nbrep = 0;
    _AllerXY( 0 , _premLigne );
    while( p_reponses[ nbrep ] != '\0' && nbrep < _nbRepPremCol )
    {
            _AllerXY( _NbLColEcran / 8 , _premLigne + nbrep ) ;
            sprintf( ChAux , "%c  " , p_reponses[ nbrep ] );
            printf( ChAux );
            if( p_reponses[ nbrep ] != ' ')
            {
                    printf( p_rubriques[ nbrep ] );
            }
            printf("\n");
            nbrep++;
    }
    _AllerXY( 6 , 23 );
    printf( "Votre reponse : " );
    nbrep--;

    do
    {
           _AllerXY( 22 , 23 );
           printf( "      \n" );
           _AllerXY( 22 , 23 );

#ifdef SUN
          carPrec = (reponse = getchar() );
          while( !( _Return( reponse ) ) )
          {
                carPrec = reponse;
                reponse = getchar();
          }
          reponse = carPrec;
#else
          reponse = getchar();
#endif

          if( reponse != ' ')
          {
              for ( i = 0 ; i <= nbrep ; i++ )
              {
                if( reponse == p_reponses[i] )
                    return i;
              }
          }
          sprintf( chaine , "%c" , '\7' );
          printf( chaine );
    }
    while( _False != _True );
}

/****************************************************************************
             INFORMATION DURANT UN PROCESS
*****************************************************************************/
void     TxtTitresDialogueInfo( int p_indTitre , int p_indNomCommentaire1,
                                int p_indNomCommentaire2 )
{
    char                chTitre[ 256 ];
    char                chComment1[ 256 ];
    char                chComment2[ 256 ];

    if( TraitementBatch )
    {
        return;
    }

    if( _MachineGraphique )
    {
        _TitresDialogueInfo( p_indTitre , p_indNomCommentaire1,
                             p_indNomCommentaire2 );
        return;
    }

    _Cs();

    if( p_indTitre > 0 )
    {
        TxtChaineRsrc( 131 , p_indTitre , chTitre );
        _AllerXY( (_NbLColEcran - strlen( chTitre )) / 2 , 2);
        printf( chTitre );
        printf("\n");
    }

    if( p_indNomCommentaire1 > 0 )
    {
        TxtChaineRsrc( 131 , p_indNomCommentaire1 , chComment1 );
        _AllerXY(18,5);
        printf( chComment1 );
        printf("\n");
    }
    if( p_indNomCommentaire2 > 0 )
    {
        TxtChaineRsrc( 131 , p_indNomCommentaire2 , chComment2 );
        _AllerXY(18,7);
        printf( chComment2 );
        printf("\n");
    }
}

/************************************************************************
            Ecriture dans un item de dialogue
************************************************************************/
void     TxtEcritItemInfo( int p_noItem , char *p_chaine )
{
    char             chAux[ 256 ];

    if( TraitementBatch )
    {
        return;
    }

    if( _MachineGraphique )
    {
         _EcritItemInfo( p_noItem , p_chaine );
         return;
    }

    if( p_noItem == 1 )
    {
        _AllerXY(50,5);
    }
    else if( p_noItem == 2 )
    {
        _AllerXY(50,7);
    }
    sprintf( chAux , "%30s\n" , p_chaine );
    printf( chAux );
}

/************************************************************************
                            Alerte
************************************************************************/

void     TxtAlerte( int p_indTexte , int p_noIcon )
{
    char                chComment[ 256 ];

    /* instruction bidon pour eviter un warniong en compil sur une var
       inutilisee */
    {
        int  no_iconLocal;
        no_iconLocal = p_noIcon;
    }

    if( _MachineGraphique )
    {
        _Alerte( p_indTexte , p_noIcon );
    }
    else
    {
        TxtChaineRsrc( 133 , p_indTexte , chComment );

        printf( "fastr: Warning %d: %s\n" , 
               p_indTexte , chComment );

        if( !TraitementBatch )
        {
            TxtAttente();
        }
    }
}

/************************************************************************
                            erreurs de compilation
************************************************************************/

void     TxtErreurCompil( char *p_texte1 , char *p_texte2 )
{
    /* instruction bidon pour eviter un warniong en compil sur une var
       inutilisee */
    {
        char     *p_chLocal;
        p_chLocal = p_texte1;
        p_chLocal = p_texte2;
    }

    if( _MachineGraphique )
    {
         _DialErreurCompil( p_texte1 , p_texte2 );
    }
}

/*******************************************************************************
                         DESSIN D'UN ARBRE SYNTAXIQUE
*******************************************************************************/
void     DessineTerme( int p_haut , int p_gauche ,
                      int p_hauteur , int p_largeur , char *p_ch1 )
{
    UnRect                      rectangle;

    /* instruction bidon pour eviter un warniong en compil sur une var
       inutilisee */
    {
        char     *p_chLocal;
        p_chLocal = p_ch1;
    }

    _CrayonNormal();
    _CaractTexte( 9 , 0 , _SourceXOR );

    _DefinirRectangle( &rectangle , p_gauche , p_haut ,
                       p_gauche + p_largeur , p_haut + p_hauteur );

    _TracerRectangle( &rectangle );
    _DessineChaine( p_gauche + 5 , p_haut + p_hauteur/2 , p_ch1 + 5 );
}

/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
                        fin de algraph.c
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
